(function($) {
    // Make sure you run this code under Elementor..
    $(window).on('elementor/frontend/init', function() {
        var widgets = {
            // 'jws_menu_nav.default': jws_menu_style,
            'jws_search.default': jws_search,
            'jws_product_listing.default': [jws_products_slider],
            'jws_testimonial_slider.default': testimonial_slider,
            'jws_show.default': [show_filter],
            'jws_login_form.default': login_form,
            'jws_video_popup.default': video_popup,
            'jws_map.default': WidgetjwsGoogleMapHandler,
            'jws_blog_tab.default': [blog_tabs, jws_carousel],
            'jws-avenchart.default': [jwsChartHandler], 
            'jws_gallery.default': jws_gallery,
            'jws_tab.default': jws_tabs,
            'jws_heading_content.default': heading_animation,
            'jws-price-table.default': show_detail_price_info,
            'jws_cf7.default': jws_cf7,
            'jws_agencys_form.default': jws_cf7,
            'jws_tongle_switch.default': jws_tongle_switch,
            'jws_services.default': jws_services,
            'jws_blog.default': [blogLoadMore, jws_blog_item, blog_filter, override_section_close],
            'jws_progress.default': progress,

        };

        $.each(widgets, function(widget, callback) {
            if ('object' === typeof callback) {
                $.each(callback, function(index, cb) {
                    elementorFrontend.hooks.addAction('frontend/element_ready/' + widget, cb);
                });
            } else {
                elementorFrontend.hooks.addAction('frontend/element_ready/' + widget, callback);
            }
        });
    });
    	//function progress elementor
	var progress = function ($scope, $) {

		$scope.find('.jws-progress').eq(0).each(function () {
			var $this = $(this);



			var cans = document.querySelectorAll('canvas');
			var device = $('body').data('elementor-device-mode');
			function cans_progress() {
				cans.forEach(can => {

					var
						spanProcent = can.nextElementSibling,
						c = can.getContext('2d'),
						width_canvas = 0,
						height_canvas = 0,
						line_canvas = 0;

					width_canvas = can.width;
					height_canvas = can.height;
					line_canvas = 10;



					var posX = width_canvas / 2,
						posY = height_canvas / 2,
						fps = 1000 / 200,
						procent = 0,
						oneProcent = 360 / 100,
						data_percent = can.getAttribute('data-percent'),
						data_title = can.getAttribute('data-title'),
						color1 = can.getAttribute('data-color1'),
						color2 = can.getAttribute('data-color2'),
						color3 = can.getAttribute('data-color3'),
						result = oneProcent * data_percent;

					c.lineCap = 'round';
					arcMove();

					function arcMove() {
						var deegres = 0;
						var radius = posX - 5;
						var gradient = c.createLinearGradient(0, 0, 0, 170);
						gradient.addColorStop("0.1", color1);
						gradient.addColorStop("1.0", color2);
						var acrInterval = setInterval(function () {
							deegres += 1;
							c.clearRect(0, 0, can.width, can.height);
							procent = deegres / oneProcent;

							spanProcent.innerHTML = data_title + '<p>' + procent.toFixed() + '</p>';

							c.beginPath();
							c.arc(posX, posY, radius, (Math.PI / 180) * 270, (Math.PI / 180) * (270 + 360));
							c.strokeStyle = color3;
							c.lineWidth = line_canvas;
							c.stroke();

							c.beginPath();
							c.strokeStyle = gradient;
							c.lineWidth = line_canvas;
							c.arc(posX, posY, radius, (Math.PI / 180) * 270, (Math.PI / 180) * (270 + deegres));
							c.stroke();
							if (deegres >= result) clearInterval(acrInterval);
						}, fps);

					}
				});

			};

			$this.appear(function () {
				cans_progress();
			});


		});
	}
    var isOnScreen = function(el) {
        var win = $(window);
        var viewport = {
            top: win.scrollTop(),
            left: win.scrollLeft()
        };
        viewport.right = viewport.left + win.width();
        viewport.bottom = viewport.top + win.height();

        var bounds = el.offset();
        bounds.right = bounds.left + el.outerWidth();
        bounds.bottom = bounds.top + el.outerHeight();

        return (!(viewport.right < bounds.left || viewport.left > bounds.right || viewport.bottom < bounds.top || viewport.top > bounds.bottom));
    };
    var jws_services = function ($scope, $) {
		$scope.find('.elementor-widget-container').eq(0).each(function () {

			var $this = $(this);
			$this.find('.jws_services_item').hover(function () {
				$this.find('.jws-services-element .jws_services_item').removeClass("active");
				$(this).addClass("active");
			});
		});
	}
    var heading_animation = function($scope, $) {
        $scope.find('.jws_heading').eq(0).each(function() {
            var $this = $(this);
            /**
             * Check if el is on screen
             */
            var animation = $this.data('animations');

            if ($('body').length > 0) {
                $(window).scroll(function() {

                    if ($this.length > 0) {
                        if (isOnScreen($this) === !0) {
                            $this.find('.heading-tagline').addClass('animated').addClass(animation);
                            $this.find('.heading-tagline').css('opacity', '1');
                            $this.find('.heading-title').addClass('animated').addClass(animation);
                            $this.find('.heading-title').css('opacity', '1');
                            $this.find('.content').addClass('animated').addClass(animation);
                            $this.find('.content').css('opacity', '1');
                            $this.find('.btn-button').addClass('animated').addClass(animation);
                            $this.find('.btn-button').css('opacity', '1');
                        }
                    }
                });
            }
        });

    };
    var jws_tongle_switch = function($scope, $) {
        $scope.find('.jws_tongle_switch').eq(0).each(function() {
            var $this = $(this);
            
            $this.find('.tongle-check').click(function() {
                if($this.find('.tongle-check').is(":checked")) {
                    $this.find('.jws_tongle_secondary').addClass('active');
                    $this.find('.jws_tongle_primary').addClass('hidden');
                    $this.find('.toggle-btn').addClass('active');
                } else if($this.find('.tongle-check').is(":not(:checked)")){
                    $this.find('.jws_tongle_secondary').removeClass('active');
                    $this.find('.jws_tongle_primary').removeClass('hidden');
                    $this.find('.toggle-btn').removeClass('active');
                }
            })
            
        });

    };
    	var jws_tabs = function ($scope, $) {
		$scope.find('.jws_tab_wrap').eq(0).each(function () {
			var $this = $(this);

			/* Line magic tabs filter */
			var leftPos, newWidth, $magicLine;
			if ($this.find('.tab_nav').length) {
				$this.find('.tab_nav').append("<li id='magic_line'></li>");
				$magicLine = $this.find('#magic_line');
				$magicLine
					.width($this.find('.current').width())
					.height($this.find('.tab_nav').height())
					.css('left', $this.find('.current a').position().left)
					.data('origLeft', $magicLine.position().left)
					.data('origWidth', $magicLine.width())
				$this.find('.tab_nav li a').on("click", function (e) {
					e.preventDefault();
					var $this = $(this);
					$(document).trigger('resize');
					$magicLine
						.data('origLeft', $this.position().left)
						.data('origWidth', $this.parent().width())
					return false;
				});

				/*Magicline hover animation*/
				$this.find('.tab_nav li').find('a').click(function () {
					$magicLine.css({
						"left": $magicLine.data('origLeft'),
						"width": $magicLine.data('origWidth'),
					});
				});
			}

			$('.tab_nav li a').click(function (e) {
				e.preventDefault();
				var tab_id = $(this).attr('data-tab');

				$('.tab_nav li a').parent().removeClass('current');
				$('.jws_tab_item').removeClass('current');

				$(this).parent().addClass('current');
				$("#" + tab_id).addClass('current');
			})

		});
	}
    var jws_carousel = function($this) {
	var $currentTarget = $this.find(".slider-layout:not(.slick-slider)");
	$currentTarget.eq(0).each(function() {
		var data = JSON.parse($(this).attr('data-jws-config'));
		var slides_to_show = data['slides_to_show'];
		var slides_to_show_tablet = data['slides_to_show_tablet'];
		var slides_to_show_mobile = data['slides_to_show_mobile'];
		var scroll = data['scroll'];
		var autoplay = data['autoplay'];
		var autoplay_tablet = data['autoplay_tablet'];
		var autoplay_mobile = data['autoplay_mobile'];
		var speed = data['speed'];
		var show_pag = data['show_pag'];
		var show_pag_tablet = data['show_pag_tablet'];
		var show_pag_mobile = data['show_pag_mobile'];
		var show_nav = data['show_nav'];
		var show_nav_tablet = data['show_nav_tablet'];
		var show_nav_mobile = data['show_nav_mobile'];
		var wrap = data['wrap'] != undefined ? data['wrap'] : '';
		var arrow_left = data['arrow_left'] != undefined ? data['arrow_left'] : 'arrow_carrot-left';
		var arrow_right = data['arrow_right'] != undefined ? data['arrow_right'] : 'arrow_carrot-right';
		var center_mode = data['center_mode'] != undefined ? data['center_mode'] : false;
		var infinite = data['infinite'] != undefined ? data['infinite'] : true;
		$(this).find('.carousel').not('.slick-initialized').slick({
			infinite: infinite,
			slidesToShow: slides_to_show,
			slidesToScroll: scroll > slides_to_show ? slides_to_show : scroll,
			arrows: show_nav,
			dots: show_pag,
			prevArrow: '<button class="slick-arrow slick-prev"><i aria-hidden="true" class="eva eva-arrow-back-outline"></i></button>',
			nextArrow: '<button class="slick-arrow slick-next"><i aria-hidden="true" class="eva eva-arrow-forward-outline"></i></button>',
			autoplay: autoplay,
			autoplaySpeed: speed,
			rtl: $('body.rtl')[0] ? true : false,
			centerMode: center_mode,
			centerPadding: '0',
			responsive: [{
				breakpoint: 1026,
				settings: {
					slidesToShow: slides_to_show_tablet,
					slidesToScroll: scroll > slides_to_show_tablet ? slides_to_show_tablet : scroll,
					autoplay: autoplay_tablet,
					arrows: show_nav_tablet,
					dots: show_pag_mobile,
				}
			}, {
				breakpoint: 768,
				settings: {
					slidesToShow: slides_to_show_mobile,
					slidesToScroll: scroll > slides_to_show_mobile ? slides_to_show_mobile : scroll,
					autoplay: autoplay_mobile,
					arrows: show_nav_tablet,
					dots: show_pag_mobile,
				}
			}, {
				breakpoint: 360,
				settings: {
					slidesToShow: 1,
					slidesToScroll: 1
				}
			}]
		});


	});
};
     var show_detail_price_info = function($scope, $) {
        $scope.find('.jws-price-table').eq(0).each(function() {
            var $this = $(this);
           
                $this.find('.jws-price-table__details').click( function(){
                    if($this.hasClass('tongle-active')) {
                        
                        $this.removeClass('tongle-active');
                        $this.attr("style","");  
                    }else {
                        $('.jws-price-table').removeClass('tongle-active');
                        $('.jws-price-table').attr("style","");  
                        $this.addClass('tongle-active');
                        var detail_height = $this.find('.jws-price-table__details-list').outerHeight();
                            $this.css('padding-bottom', detail_height );
                        
                    }
                })
        });

    };
    var jws_cf7 = function($scope, $) {
         document.addEventListener( 'wpcf7mailsent', function( event ) {
          $('.jws-cf7').find("input, textarea").parent().parent().removeClass('active');
        }, false );
        $scope.find('.jws-cf7').eq(0).each(function() {
            var $this = $(this);
            
                $this.find("input, textarea").focus(function(){
                	$(this).parent().parent().addClass('active');
                }).blur(function(){
                	var cval = $(this).val()
                	if(cval.length < 1) {$(this).parent().parent().removeClass('active');}
                })
        });

    };
    /// menu
    var jws_menu_style = function($scope, $) {
        if ('undefined' == typeof $scope) {
            return;
        }
        $scope.find('.jws_main_menu').eq(0).each(function() {
            var $this = $(this);

            $(window).load(function() {

                var main = $this.find(".jws_nav"),

                    curent_item = main.find('> li.current-menu-item'),
                    curent_item_sub = main.find('ul li.current-menu-item');
                if (main.find('> li.current-menu-item').length == 0) {
                    if (curent_item_sub.length > 0) {
                        curent_item = curent_item_sub.parents('.jws_nav > li');
                    } else {
                        curent_item = main.find('> li:first-child');
                    }

                }
                var pos = curent_item.width() / 2;
                /* Line magic tabs filter */
                var $magicLine;

                if (main.length) {
                    main.append("<span id='magic_line'></span>");
                    $magicLine = $this.find('#magic_line');
                    $magicLine
                        .css('left', (curent_item.position().left + pos))
                        .data('origLeft', ($magicLine.position().left));

                    /*Magicline hover animation*/

                    main.find('> li').hover(function() {
                        var $thisBar = $(this),
                            decv = $thisBar.width() / 2,
                            leftPos = $thisBar.position().left + decv;
                        $magicLine.css({
                            "left": leftPos,
                        });
                    }, function() {
                        $magicLine.css({
                            "left": (curent_item.position().left + pos),
                        });
                    });
                }

            });

        });

    };

    var jws_gallery = function($scope, $) {

        $scope.find('.jws_gallery_element').eq(0).each(function() {
            var $this = $(this),
                $container = $this.find('.jws_gallery');
            $item = $container.find('.jws_gallery_item').not(".slick-cloned");
            //init flickity
            var pageDots = false;
            if ($container.hasClass('has-dots')) {
                pageDots = true;
            }
            if ($container.hasClass('slider')) {
                $container.not('.slick-initialized').slick({
                    	prevArrow: '<button class="slick-arrow slick-prev"><i aria-hidden="true" class="eva eva-arrow-back-outline"></i></button>',
			nextArrow: '<button class="slick-arrow slick-next"><i aria-hidden="true" class="eva eva-arrow-forward-outline"></i></button>',
                });
            }
            if (!$container.hasClass('slider')) {
                $(window).on("load", function() {
                    if ($container.hasClass('metro')) {
                        $container.isotope({
                            itemSelector: ".jws_gallery_item",
                            layoutMode: 'packery',
                        });
                    } else {
                        $container.isotope({
                            itemSelector: ".jws_gallery_item",
                            layoutMode: 'masonry',
                            transitionDuration: "0.3s",
                        });
                    }
                });
            }


        });
    };
      /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * Blog Tab
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
   var blog_tabs = function($scope, $) {
    var wrap = $scope.find('.jws-wrap');
    wrap.find('.jws-ajax-load a.ajax-load').on('click', function(e) {
        e.preventDefault();
        var $this = $(this);
        var key = $this.data('value');
        wrap = $this.parents('.append-class');
        if ($this.hasClass('active')) {
            return;
        }
        $this.parents('.jws-ajax-load ').find('a').removeClass('active');
        $this.addClass('active');
        if ($this.hasClass('opened')) {
        
            wrap.find('.blogs-tab').html(wrap.find('.blogs-tab').data(key)).addClass('animated-global');
            var iter = 0;
            intervalID = setInterval(function() {
                wrap.find('.blog-item').eq(iter).addClass('jws-animated');
                iter++;
            }, 100);
            if (wrap.hasClass('jws_blogs_slider')) {
                wrap.find('.blogs').removeClass('slick-initialized slick-slider slick-dotted');
                jws_carousel($scope);
            }
            return;
        }
        $this.addClass('opened');
        wrap.addClass('loading');
        var data = wrap.data('args');
        data['action'] = 'jws_ajax_blog_tab';
       
            data['tab_categories'] = $this.data('value');
       
       
        wrap.data('args', data);
        $.ajax({
            url: wrap.data('url'),
            data: data,
            type: 'POST',
        }).success(function(response) {
            $scope.find('.blogs').addClass('jws-animated-blogs jws-animated-blogs-filter');
            wrap.removeClass('loading');
            let content = $(response).html();
            $blog_list = wrap.find('.blogs');
            wrap.find('.blogs-tab').html(content);
            wrap.find('.blogs-tab').data(key, content);
            var iter = 0;
            $blog_list.find('.blog-item').addClass('animated-global');
            intervalID = setInterval(function() {
                $blog_list.find('.blog-item').eq(iter).addClass('jws-animated');
                iter++;
            }, 100);

            if (wrap.hasClass('jws_blogs_slider')) {
                wrap.find('.blogs').removeClass('slick-initialized slick-slider slick-dotted');
                jws_carousel($scope);
            }
        }).error(function(ex) {
            console.log(ex);
        });
    });
};
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * Login Form
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
    var login_form = function($scope, $) {
          $scope.find('#loginform').ready(function() {
                    var $this = $(this);
                    var input = $this.find("input, textarea")
                        input.each(function(){
                            if($(this).val().length > 0) {
                           	    $(this).parents('.form-group').addClass('active');
                            }
                        
                        });
                        input.focus(function(){
                        	$(this).parents('.form-group').addClass('active');
                        }).blur(function(){
                        	var cval = $(this).val()
                        	if(cval.length < 1) {$(this).parents('.form-group').removeClass('active');}
                        })
                });
        $scope.find('#jws-popup-login').eq(0).each(function() {
            $('.toggle-password').on('click', function() {
                $(this).toggleClass('eva-eye-off-outline');
                var password = $(this).parent().find('.pwd');
                var password_repeat = $(this).parent().find('#repeat_pwd');
                if (password.attr('type') == 'password') {
                    password.attr('type', 'text');
                } else {
                    password.attr('type', 'password');
                }
                if (password_repeat.attr('type') == 'password') {
                    password_repeat.attr('type', 'text');
                } else {
                    password_repeat.attr('type', 'password');
                }
            });

            $('#jws-popup-login').eq(0).each(function() {
                $(this).find('form[name=loginpopopform]').ready(function() {
                    if (!($(this).find('.login-username input.required').val()) && !($(this).find('.login-password input.required').val())) {
                        $(this).find('.button').prop("disabled", true).css({
                            'cursor': 'not-allowed'
                        });
                    }
                });
                $(this).find('form[name=loginpopopform]').on('change', function() {
                    if (($(this).find('.login-username input.required').val()) || ($(this).find('.login-password input.required').val())) {
                        $(this).find('.button').prop("disabled", false).css({
                            'cursor': 'auto'
                        });
                    }
                });
                $(this).find('form[name=loginpopopform]').on('submit', function(event) {
                    event.preventDefault();
                    if (!($(this).find('.login-username input.required').val()) && !($(this).find('.login-password input.required').val())) {
                        $(this).find('.button').prop("disabled", true).css({
                            'cursor': 'not-allowed'
                        });
                    }
                    var valid = true,
                        email_valid = /[A-Z0-9._%+-]+@[A-Z0-9.-]+.[A-Z]{2,4}/igm;
                    $(this).find('.error').remove();
                    $(this).find('input.required').each(function() {
                        // Check empty value
                        if (!$(this).val()) {
                            if ($(this).attr('name') == 'log') {

                                $(this).after('<span class="error">Please enter your username</span>');
                            }

                            // pass
                            if ($(this).attr('name') == 'pwd') {

                                $(this).after('<span class="error">Please enter your Password</span>');
                            }
                            // Uncheck
                            if ($(this).is(':checkbox') && !$(this).is(':checked')) {
                                $(this).addClass('invalid');
                                valid = false;
                            }
                            // Check email format
                            if ('email' === $(this).attr('type')) {
                                if (!email_valid.test($(this).val())) {
                                    $(this).addClass('invalid');
                                    valid = false;
                                }
                            }
                        }
                    });
                    $(this).find('input.required').on('focus', function() {
                        $(this).removeClass('invalid');
                    });
                    if (!valid) {
                        return valid;
                    }
                    var form = $(this),
                        $elem = $('#jws-popup-login .jws-login-container'),
                        wp_submit = $elem.find('input[type=submit]').val();
                    $elem.addClass('loading');
                    $elem.find('.message').slideDown().remove();
                    var data = {
                        action: 'jws_login_ajax',
                        data: form.serialize() + '&wp-submit=' + wp_submit,
                    };
                    $.post(MS_Ajax.ajaxurl, data, function(response) {
                        try {
                            response = JSON.parse(response);
                            $elem.find('.jws-login').append(response.message);
                            if (response.code == '1') {
                                if (response.redirect) {
                                    if (window.location.href == response.redirect) {
                                        location.reload();
                                    } else {
                                        window.location.href = response.redirect;
                                    }
                                } else {
                                    location.reload();
                                }
                            } else {
                                var $captchaIframe = $('#jws-popup-login .gglcptch iframe');
                                if ($captchaIframe.length > 0) {
                                    $captchaIframe.attr('src', $captchaIframe.attr('src')); // reload iframe
                                }
                            }
                        } catch (e) {
                            return false;
                        }
                        $elem.removeClass('loading');
                    });
                    return false;
                });
                $(this).find('form[name=registerformpopup]').ready(function() {
                    if (!($(this).find('.user_login input.required').val()) && !($(this).find('.user_email input.required').val()) && !($(this).find('.login-password input.required').val()) && !($(this).find('.login-password-repeater input.required').val())) {
                        $(this).find('.button').prop("disabled", true).css({
                            'cursor': 'not-allowed'
                        });
                    }
                });
                $(this).find('form[name=registerformpopup]').on('change', function() {
                    if (($(this).find('.user_login input.required').val()) || ($(this).find('.user_email input.required').val()) || ($(this).find('.login-password input.required').val()) || ($(this).find('.login-password-repeater input.required').val())) {
                        $(this).find('.button').prop("disabled", false).css({
                            'cursor': 'auto'
                        });
                    }
                });
                $(this).find('form[name=registerformpopup]').on('submit', function(e) {
                    e.preventDefault();
                    var registerform = $(this);
                    if (!($(this).find('.user_login input.required').val()) && !($(this).find('.user_email input.required').val()) && !($(this).find('.login-password input.required').val()) && !($(this).find('.login-password-repeater input.required').val())) {
                        $(this).find('.button').prop("disabled", true).css({
                            'cursor': 'not-allowed'
                        });
                    }
                    var valid = true,
                        email_valid = /[A-Z0-9._%+-]+@[A-Z0-9.-]+.[A-Z]{2,4}/igm;
                    registerform.find('.error').remove();
                    registerform.find('input.required').each(function() {
                        // Check empty value
                        if (!$(this).val()) {
                            $(this).addClass('invalid');

                            if ($(this).attr('name') == 'user_login') {

                                $(this).after('<span class="error">Please enter your username</span>');
                            }

                            // email
                            if ($(this).attr('name') == 'user_email') {

                                $(this).after('<span class="error">Please enter your Email</span>');
                            }
                            // pass
                            if ($(this).attr('name') == 'password') {

                                $(this).after('<span class="error">Please enter your Password</span>');
                            }
                            // repeater pass
                            if ($(this).attr('name') == 'repeat_password') {

                                $(this).after('<span class="error">Please enter your Repeater Password</span>');
                            }

                            valid = false;
                        }
                        // Uncheck
                        if ($(this).is(':checkbox') && !$(this).is(':checked')) {
                            $(this).addClass('invalid');
                            valid = false;
                        }
                        if ($(this).attr('name') == 'user_email' && $(this).val() && !email_valid.test($(this).val())) {
                            $(this).addClass('invalid');
                            $(this).after('<span class="error">Your Email is invalid</span>');
                            valid = false;
                        }


                    });

                    if (!valid) {
                        return valid;
                    }
                    var $form = $(this),
                        data = {
                            action: 'jws_register_ajax',
                            data: $form.serialize() + '&wp-submit=' +
                                $form.find('input[type=submit]').val(),
                            register_security: $form.find('#register_security').
                            val(),
                        },
                        $elem = $('#jws-popup-login .jws-login-container');
                    $elem.addClass('loading');
                    $elem.find('.message').slideDown().remove();
                    $.ajax({
                        type: 'POST',
                        url: MS_Ajax.ajaxurl,
                        data: data,
                        success: function(response) {

                            $elem.removeClass('loading');
                            $elem.find('.popup-message').html(response.data.message);

                            if (response.success === true) {
                                $elem.find('.jws-register').html(response.data.message);
                            }

                        },
                    });
                });

                // Check Strong Passwoed /
                $(this).find('.jws-register input[name="password"]').keyup(function() {
                    checkpassword($(this).val());
                });

                function checkpassword(password) {
                    var strength = 0,
                        meter = $('.meter'),
                        meter_text = $('.text-meter'),
                        password_hint = $('.jws-password-hint'),
                        btn_submit = $('input[name="wp-submit"]');

                    if (password.match(/[a-z]+/)) {
                        strength += 1;
                    }
                    if (password.match(/[A-Z]+/) && password.length >= 8) {
                        strength += 1;
                    }
                    if (password.match(/[0-9]+/) && password.length >= 12) {
                        strength += 1;
                    }
                    if (password.match(/[$@#&!]+/) && password.length >= 14) {
                        strength += 1;

                    }

                    if (password.length > 0) {
                        meter.show();
                        password_hint.show();
                        btn_submit.attr("disabled", "disabled");
                    } else {
                        meter.hide();
                        password_hint.hide();
                    }
                    console.log(Verify_Ajax.metera);

                    switch (strength) {
                        case 0:
                            meter_text.html("");
                            meter.attr("meter", "0");
                            break;

                        case 1:
                            meter_text.html(Verify_Ajax.metera);
                            meter.attr("meter", "1");
                            break;

                        case 2:
                            meter_text.html(Verify_Ajax.meterb);
                            meter.attr("meter", "2");
                            btn_submit.removeAttr("disabled");
                            break;

                        case 3:
                            meter_text.html(Verify_Ajax.meterc);
                            meter.attr("meter", "3");
                            btn_submit.removeAttr("disabled");
                            password_hint.hide();
                            break;

                        case 4:
                            meter_text.html(Verify_Ajax.meterd);
                            meter.attr("meter", "4");
                            btn_submit.removeAttr("disabled");
                            password_hint.hide();
                            break;
                    }
                }
                $('#jws-popup-login .link-bottom a.login').on('click', function(e) {
                    e.preventDefault();
                    $('.jws-login').addClass('active');
                    $('.jws-register').removeClass('active');
                });
                $('#jws-popup-login .link-bottom a.register').on('click', function(e) {
                    e.preventDefault();
                    $('.jws-register').addClass('active');
                    $('.jws-login').removeClass('active');
                });
            });

        });
    };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * search
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
   	/**
	 *-------------------------------------------------------------------------------------------------------------------------------------------
	 * Search
	 *-------------------------------------------------------------------------------------------------------------------------------------------
	 */
	var jws_search = function($scope, $) {
		if('undefined' == typeof $scope) return;
		$scope.find('.jws_search').eq(0).each(function() {
			var s = $(this);
			var openClass = 'open',
				button = s.find('> button');
			s.find(button).on('click', function(e) {
				e.preventDefault();
				if(!s.hasClass(openClass)) {
					s.addClass(openClass);
					setTimeout(function() {
						s.find('input.search-field').focus();
					}, 100);
					return false;
				} else {
					s.removeClass(openClass);
				}
				if(!$(e.target).closest('.search-form').length) {
					if(s.hasClass(openClass)) {
						s.removeClass(openClass);
					}
				}
			});
			$('body').on('click', function(e) {
				if(!$(e.target).closest('.search-form').length) {
					if(s.hasClass(openClass)) {
						s.removeClass(openClass);
					}
				}
			});
		});
	};
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * Product Slider
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
    var jws_products_slider = function unction($scope, $) {
        $scope.find('.jws-products-element').eq(0).each(function() {
            var $this = $(this);
             var   parrent_has_out_arrow = $this.parents( ".elementor-top-section" );
                   if(parrent_has_out_arrow.find('.elementor-widget-icon').hasClass('arrow-prev-out') || parrent_has_out_arrow.find('.elementor-widget-icon').hasClass('arrow-next-out')) {
                     var prevArrow = $('.arrow-prev-out .elementor-icon'),
                    nextArrow = $('.arrow-next-out .elementor-icon');
                }
                else {
                       var prevArrow =  '<button class="slick-arrow slick-prev"><i aria-hidden="true" class="eva eva-arrow-back-outline"></i></button>',
                       nextArrow = '<button class="slick-arrow slick-next"><i aria-hidden="true" class="eva eva-arrow-forward-outline"></i></button>'
                    
                }
            $this.find('.jws_products_slider').not('.slick-initialized').slick({
              
                     prevArrow: prevArrow,
                    nextArrow: nextArrow
               
                
              
            });
        });
    };

    var product_tabs = function($scope, $) {
        var wrap = $scope.find('.jws-wrap');
        wrap.find('.jws-ajax-load a.ajax-load').on('click', function(e) {
            e.preventDefault();
            var $this = $(this);
            var key = $this.data('value');
            wrap = $this.parents('.append-class');
            if ($this.hasClass('active')) {
                return;
            }
            $this.parents('.jws-ajax-load ').find('a').removeClass('active');
            $this.addClass('active');
            if ($this.hasClass('opened')) {
                wrap.find('.products').html(wrap.find('.products').data(key));
                wrap.find('.products').html(wrap.find('.product-item').addClass('animated-global'));
                var iter = 0;
                intervalID = setInterval(function() {
                    wrap.find('.product-item').eq(iter).addClass('jws-animated');
                    iter++;
                }, 100);

                if (wrap.hasClass('jws_products_slider')) {
                    wrap.find('.products').removeClass('slick-initialized slick-slider slick-dotted');
                    jws_carousel($scope);
                }
                return;
            }
            $this.addClass('opened');
            wrap.addClass('loading');
            var data = wrap.data('args');
            data['action'] = 'jws_ajax_product_tab';
            if ($this.data('type') == 'product_cat') {
                data['tab_categories'] = $this.data('value');
            }
            if ($this.data('type') == 'asset_type') {
                data['asset_type'] = $this.data('value');
            }
            wrap.data('args', data);
            $.ajax({
                url: wrap.data('url'),
                data: data,
                type: 'POST',
            }).success(function(response) {
                $scope.find('.products').addClass('jws-animated-products jws-animated-products-filter');
                wrap.removeClass('loading');
                let content = $(response).html();
                $product_list = wrap.find('.products');
                wrap.find('.products').html(content);
                wrap.find('.products').data(key, content);
                var iter = 0;
                $product_list.find('.product-item').addClass('animated-global');
                intervalID = setInterval(function() {
                    $product_list.find('.product-item').eq(iter).addClass('jws-animated');
                    iter++;
                }, 100);

                if (wrap.hasClass('jws_products_slider')) {
                    wrap.find('.products').removeClass('slick-initialized slick-slider slick-dotted');
                    jws_carousel($scope);
                }
            }).error(function(ex) {
                console.log(ex);
            });
        });
    };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * show Filter
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */

    var show_filter = function($scope, $) {

        $scope.find('.jws-show-element').eq(0).each(function() {


            $('.jws_show_layout4 .jws_show_image').liquidHoverPosition();


            var $this = $(this);
            var $container = $this.find('.show-content'),
                $filter = $this.find(".show_nav");
            $item = $container.find('.jws_show_item');

            loadmore_btn($this);

            /** Line magic tabs filter **/
            var $magicLine;
            if ($filter.length) {
                $filter.append("<li id='magic_line'></li>");
                $magicLine = $this.find('#magic_line');
                $magicLine
                    .width($this.find('.filter-active').parent().width())
                    .css('left', $this.find('a.filter-active').position().left)
                    .data('origLeft', $magicLine.position().left)
                    .data('origWidth', $magicLine.width());

                /*Magicline hover animation*/

                $this.find('.show_nav li').find('a').hover(function() {
                    var $thisBar = $(this);
                    leftPos = $thisBar.position().left;
                    newWidth = $thisBar.parent().width();
                    $magicLine.css({
                        "left": leftPos,
                        "width": newWidth,
                    });
                }, function() {
                    $magicLine.css({
                        "left": $this.find('a.filter-active').position().left,
                        "width": $this.find('.filter-active').parent().width(),
                    });
                });
            }

            if (!$container.hasClass('slider')) {
                $(window).on("load resize", function() {

                    if ($container.hasClass('masonry')) {
                        $container.isotope({
                            itemSelector: ".jws_show_item",
                            layoutMode: 'packery',
                            transitionDuration: "0.7s",
                            masonry: {
                                // use outer width of grid-sizer for columnWidth
                                columnWidth: '.grid-sizer',
                            }
                        });
                    } else if ($container.hasClass('metro')) {
                        $container.isotope({
                            itemSelector: ".jws_show_item",
                            layoutMode: 'packery',
                            transitionDuration: "0.7s",
                        });
                    } else {
                        $container.isotope({
                            itemSelector: ".jws_show_item",
                            layoutMode: 'fitRows',
                            transitionDuration: "0.7s",
                        });
                    }


                    $filter.find("a").click(function(e) {
                        var $t = $(this),
                            selector = $t.data("filter");
                        // Don't proceed if already selected
                        if ($t.hasClass("filter-active"))
                            return false;

                        $filter.find("a").removeClass("filter-active");
                        $t.addClass("filter-active");
                        $container.isotope({
                            filter: selector
                        });

                        e.stopPropagation();
                        e.preventDefault();

                    });
                    $container.on('layoutComplete',
                        function(event, laidOutItems) {
                            var $items = $container.find('.jws_show_item');
                            var time = 0;
                            $items.each(function() {
                                var item = jQuery(this);
                                setTimeout(function() {
                                    item.addClass('fadeIn');
                                }, time);
                                time += 200;
                            });
                        }
                    );
                });
                //$().gallery_popup($container,$item);   
            }



            // set vars
            function flicitySlider() {
                //init flickity
                var full = false;
                var intervalID;
                 var iter = 0;
                 var position = 0;
                if ($container.hasClass('has_wrap')) {
                    full = true;
                }
                $container.not('.slick-initialized').slick({
                    prevArrow: $this.find('.nav_left'),
                    nextArrow: $this.find('.nav_right'),
                    appendDots: $this.find('.custom_dots'),                   
                });
                
                intervalID = setInterval(function() {
                    position = position + 30;
                    $this.find('.custom_dots li').eq(iter).find('button').css('-webkit-transform',  'translateX(' + position+ 'px)  translateY(-50%)');
                    iter++;
                    
             
                }, 1);
            }

            function _defineProperty(obj, key, value) {
                if (key in obj) {
                    Object.defineProperty(obj, key, {
                        value: value,
                        enumerable: true,
                        configurable: true,
                        writable: true
                    });
                } else {
                    obj[key] = value;
                }
                return obj;
            }

            function fullwidthSide() {
                if (!$container.hasClass('has_wrap') || $(window).width() < 767) return;
                var _viewportElWrap$css, _viewportElWrap$css2;

                var viewportEl = $container.find('.slick-list');
                var elementWidth = viewportEl.width();
                var viewportElOffset = viewportEl.offset();
                var viewportElOffsetRight = $(window).width() - (elementWidth + viewportElOffset.left);
                var margin = !this.isRTL ? 'marginRight' : 'marginLeft';
                var padding = !this.isRTL ? 'paddingRight' : 'paddingLeft';


                viewportElWrap = viewportEl.parent();
                viewportElWrap.css((_viewportElWrap$css = {}, _defineProperty(_viewportElWrap$css, margin, ''), _defineProperty(_viewportElWrap$css, padding, ''), _viewportElWrap$css));
                viewportElWrap.css((_viewportElWrap$css2 = {}, _defineProperty(_viewportElWrap$css2, margin, viewportElOffsetRight >= 0 ? (viewportElOffsetRight - 1) * -1 : viewportElOffsetRight - 1), _defineProperty(_viewportElWrap$css2, padding, Math.abs(viewportElOffsetRight - 1)), _defineProperty(_viewportElWrap$css2, "overflow", 'hidden'), _viewportElWrap$css2));
                viewportEl.css('overflow', 'visible');
            }

            function filtersInit() {
                $filter.find("a").on("click touchstart", function(e) {
                    var $t = $(this),
                        selector = $t.data("filter");
                    // Don't proceed if already selected
                    if ($t.hasClass("filter-active"))
                        return false;

                    $filter.find("a").removeClass("filter-active");
                    $t.addClass("filter-active");
                    filterAnimateStart(selector);
                    e.stopPropagation();
                    e.preventDefault();
                });
            }

            function filterAnimateStart(filterValue) {
                anime.remove('.jws_show_item');
                anime({
                    targets: '.jws_show_item',
                    translateX: -30,
                    opacity: 0,
                    easing: 'easeInOutQuint',
                    duration: 300,
                    delay: function delay() {
                        return i * 60;
                    },
                    begin: function begin(anime) {

                        $(anime.animatables).each(function(i, el) {
                            var $element = $(el.target);
                            $element.css({
                                transition: 'none'
                            });
                        });
                    },
                    complete: function complete() {
                        if (filterValue !== '*') {

                            $container.slick('slickUnfilter');

                            $container.find('.jws_show_item').each(function() {
                                $(this).removeClass('slide-shown');
                            });

                            $(filterValue).addClass('slide-shown');

                            $container.slick('slickFilter', '.slide-shown');
                        } else {
                            $container.find('.jws_show_item').each(function() {
                                $(this).removeClass('slide-shown');
                            });
                            $container.slick('slickUnfilter');

                        }

                        filterItems(filterValue);

                    }
                });
            }

            function filterItems(filterValue) {
                //use data-filter attribute & class for filtering 
                var slider = $container;
                var slide = slider.find('.jws_show_item');

                if (filterValue == '*') {
                    // if all show all
                    slide.removeClass('hidden');
                    slide.addClass('flickity');
                } else {
                    //set active slide
                    var active = $(filterValue).removeClass('hidden');
                    // show only slide with the same class as the button "attr('data-filter')"
                    slide.addClass('flickity');
                    slide.not(active).removeClass('flickity');
                    slide.not(active).addClass('hidden');
                    // destroy slider so we can rebuild with new filters


                }
                filterAnimateComplete();
            }

            function filterAnimateComplete() {

                anime.remove('.jws_show_item');
                anime({
                    targets: '.jws_show_item',
                    translateX: 0,
                    opacity: 1,
                    easing: 'easeOutQuint',
                    delay: function delay() {
                        return i * 60;
                    },
                    complete: function complete(anime) {
                        $(anime.animatables).each(function(i, el) {
                            var element = $(el.target);
                            element.css({
                                transition: '',
                                transform: '',
                                opacity: ''
                            });
                        });
                    }
                });

            }

            if ($container.hasClass('slider')) {
                filtersInit();
                flicitySlider();
                fullwidthSide();

            }
        });
    };


    var jws_carousel = function($this) {

        var $currentTarget = $this.find(".jws_blogs_slider:not(.slick-slider)");
        $currentTarget.each(function() {
            var data = JSON.parse($(this).attr('data-jws-config'));
            var slides_to_show = data['slides_to_show'];
            var slides_to_show_tablet = data['slides_to_show_tablet'];
            var slides_to_show_mobile = data['slides_to_show_mobile'];
            var scroll = data['scroll'];
            var autoplay = data['autoplay'];
            var autoplay_tablet = data['autoplay_tablet'];
            var autoplay_mobile = data['autoplay_mobile'];
            var speed = data['speed'];
            var show_pag = data['show_pag'];
            var show_pag_tablet = data['show_pag_tablet'];
            var show_pag_mobile = data['show_pag_mobile'];
            var show_nav = data['show_nav'];
            var show_nav_tablet = data['show_nav_tablet'];
            var show_nav_mobile = data['show_nav_mobile'];
            var wrap = data['wrap'] != undefined ? data['wrap'] : '';
            var arrow_left = data['arrow_left'] != undefined ? data['arrow_left'] : 'arrow_carrot-left';
            var arrow_right = data['arrow_right'] != undefined ? data['arrow_right'] : 'arrow_carrot-right';
            var center_mode = data['center_mode'] != undefined ? data['center_mode'] : false;
            var infinite = data['infinite'] != undefined ? data['infinite'] : true;
            $(this).find('.carousel').slick({
                infinite: infinite,
                slidesToShow: slides_to_show,
                slidesToScroll: scroll > slides_to_show ? slides_to_show : scroll,
                arrows: show_nav,
                dots: show_pag,
                prevArrow: '<button class="slick-arrow slick-prev"><i aria-hidden="true" class="eva eva-arrow-back-outline"></i></button>',
                nextArrow: '<button class="slick-arrow slick-next"><i aria-hidden="true" class="eva eva-arrow-forward-outline"></i></button>',
                autoplay: autoplay,
                autoplaySpeed: speed,
                rtl: $('body.rtl')[0] ? true : false,
                centerMode: center_mode,
                centerPadding: '0',
                responsive: [{
                    breakpoint: 1026,
                    settings: {
                        slidesToShow: slides_to_show_tablet,
                        slidesToScroll: scroll > slides_to_show_tablet ? slides_to_show_tablet : scroll,
                        autoplay: autoplay_tablet,
                        arrows: show_nav_tablet,
                        dots: show_pag_mobile,
                    }
                }, {
                    breakpoint: 768,
                    settings: {
                        slidesToShow: slides_to_show_mobile,
                        slidesToScroll: scroll > slides_to_show_mobile ? slides_to_show_mobile : scroll,
                        autoplay: autoplay_mobile,
                        arrows: show_nav_tablet,
                        dots: show_pag_mobile,
                    }
                }, {
                    breakpoint: 360,
                    settings: {
                        slidesToShow: 1,
                        slidesToScroll: 1
                    }
                }]
            });


        });
    };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * testimonials_slider
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
    var testimonial_slider = function($scope, $) {
        $scope.find('.jws_testimonials_slider_wrap').eq(0).each(function() {
            $(this).find('.testimonials_slider').not('.slick-initialized').slick({
                appendDots: $(this).find('.custom_dots'),
                prevArrow: $(this).find('.slick-prev'),
                nextArrow: $(this).find('.slick-next'),
            }).on('afterChange', function(event, slick, currentSlide) {
                if ($(this).find('.custom_dots').length > 0) {
                    slick.$dots.each(function(i, el) {
                        $(el).find('li').eq(currentSlide).addClass('slick-active').find('button');
                    });
                }
            });
        });
    };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * blog over section
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
    var override_section_close = function($scope, $) {
        $scope.find('.close-popup-blog').click(function() {
            $scope.find('.get_override_content').fadeOut(300, function() {
                $scope.find('.get_override_content').remove();
            });
        });
    };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * blog slider
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */

    var jws_blog_item = function($scope, $) {
        $scope.find('.jws-blog-element').eq(0).each(function() {

            $(this).find('.jws_blog_slider').not('.slick-initialized').slick({
                prevArrow: '<button class="slick-arrow slick-prev"><i aria-hidden="true" class="eva eva-arrow-back-outline"></i></button>',
                nextArrow: '<button class="slick-arrow slick-next"><i aria-hidden="true" class="eva eva-arrow-forward-outline"></i></button>'
            });
        });


    };

    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * video popup
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
    var video_popup = function($scope, $) {
        $scope.find('.jws_video_popup').eq(0).each(function() {
            $(this).find('.jws_video_popup_inner').magnificPopup({
                delegate: 'a',
                type: 'image',
                removalDelay: 500, //delay removal by X to allow out-animation
                callbacks: {
                    beforeOpen: function() {
                        this.st.mainClass = 'mfp-zoom-in';
                    },
                    imageLoadComplete: function() {
                        var self = this;
                        setTimeout(function() {
                            self.wrap.addClass('mfp-image-loaded');
                        }, 16);
                    },
                    elementParse: function(item) {
                        item.type = 'iframe',
                            item.iframe = {
                                patterns: {
                                    youtube: {
                                        index: 'youtube.com/', // String that detects type of video (in this case YouTube). Simply via url.indexOf(index).
                                        id: 'v=', // String that splits URL in a two parts, second part should be %id%
                                        // Or null - full URL will be returned
                                        // Or a function that should return %id%, for example:
                                        // id: function(url) { return 'parsed id'; } 
                                        src: '//www.youtube.com/embed/%id%?autoplay=1' // URL that will be set as a source for iframe. 
                                    },
                                    vimeo: {
                                        index: 'vimeo.com/',
                                        id: '/',
                                        src: '//player.vimeo.com/video/%id%?autoplay=1'
                                    }
                                }
                            };
                    }
                },
            });
        });
    };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * Load more button for blog
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
    var loadmore_btn = function($scope) {

        var __this = $scope;
        var $element = $scope.find('[data-ajaxify=true]');
        var options = $element.data('ajaxify-options');
        var observer = null;
        init();


        function init() {
            var trigger = 'click';
            trigger == 'inview' && setupIntersectionObserver();
            trigger == 'click' && onClick();
        }

        function onClick() {
            $element.on('click', function(event) {
                parents = $(this).parent('.jws_pagination').siblings('.row');
                event.preventDefault();
                loadItems(parents);
            });

        }

        function setupIntersectionObserver() {

            observer = new IntersectionObserver(function(enteries) {
                enteries.forEach(function(entery) {
                    if (entery.isIntersecting) {
                        loadItems();
                    }
                });
            }, {
                threshold: [1]
            });
            observer.observe(this.element);
        }

        function loadItems($wrapper) {

            var target = $element.attr('href'); // Loading State
            $element.parent('.jws_pagination').addClass('items-loading'); // Load Items
            $.ajax({
                type: 'GET',
                url: target,
                error: function error(MLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                },
                success: function success(data) {
                    var $data = $(data);
                    var $newItemsWrapper = $data.find(options.wrapper);
                    var $newItems = $newItemsWrapper.find(options.items);
                    var nextPageUrl = $data.find('[data-ajaxify=true]').attr('href'); // Add New Items on imagesLoaded

                    ;
                    if ((nextPageUrl && nextPageUrl != '?ajaxify=1') && target != nextPageUrl) {

                        $element.attr('href', nextPageUrl);
                        $element.parent('.jws_pagination').removeClass('items-loading');
                    } else {
                        observer && observer.unobserve(element);
                        $element.parent('.jws_pagination').removeClass('items-loading').addClass('all-items-loaded');
                    } // Append new items
                    $newItems.imagesLoaded(function() {
                        $newItems.appendTo($wrapper);

                        (!$wrapper.hasClass('jws-blog-item')) && $wrapper.isotope('appended', $newItems); // Calling function for the new items
                        onSuccess($wrapper);
                    });

                }
            });
        }

        function onSuccess($wrapper) {
            jwsThemeModule.video_popup();
            //show_hover();
            $('.hover-3d').liquidHover3d();
            $('.jws_show_layout4 .jws_show_image').liquidHoverPosition();
            $element.removeClass('items-loading');
            $(".has-animation .jws-ani-item").addClass('hiden-ani');



        }

    };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * Blog Filter
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */

    var blog_filter = function($scope, $) {

        $scope.find('.jws-blog-element').eq(0).each(function() {
            var $this = $(this);
            var $container = $this.find('.blog-content'),
                $filter = $this.find(".post-nav");

            if (!$container.hasClass('jws-blog-slider')) {
                $(window).on("load resize", function() {
                    if ($container.hasClass('has-masonry')) {
                        $container.isotope({
                            itemSelector: ".jws-blog-item",
                            layoutMode: 'masonry',
                            transitionDuration: "0.3s",
                        });
                    }

                    $filter.find("a").on("click touchstart", function(e) {
                        var $t = $(this),
                            selector = $t.data("filter");
                        // Don't proceed if already selected
                        if ($t.hasClass("filter-active"))
                            return false;

                        $filter.find("a").removeClass("filter-active");
                        $t.addClass("filter-active");
                        $container.isotope({
                            filter: selector
                        });

                        e.stopPropagation();
                        e.preventDefault();

                    });
                });
            }



            // set vars
            function postslider() {
                $container.not('.slick-initialized').slick({
                    prevArrow: $this.find('.nav_left'),
                    nextArrow: $this.find('.nav_right'),
                });

            }


            function filtersInit() {
                $filter.find("a").on("click touchstart", function(e) {
                    var $t = $(this),
                        selector = $t.data("filter");
                    // Don't proceed if already selected
                    if ($t.hasClass("filter-active"))
                        return false;

                    $filter.find("a").removeClass("filter-active");
                    $t.addClass("filter-active");
                    filterAnimateStart(selector);
                    e.stopPropagation();
                    e.preventDefault();

                });

            }

            function filterAnimateStart(filterValue) {
                anime.remove('.jws-blog-item');
                anime({
                    targets: '.jws-blog-item',
                    translateX: -30,
                    opacity: 0,
                    easing: 'easeInOutQuint',
                    duration: 500,
                    delay: function delay() {
                        return i * 60;
                    },
                    begin: function begin(anime) {

                        $(anime.animatables).each(function(i, el) {
                            var $element = $(el.target);
                            $element.css({
                                transition: 'none'
                            });
                        });
                    },
                    complete: function complete() {
                        if (filterValue !== '*') {

                            $container.slick('slickUnfilter');

                            $container.find('.jws-blog-item').each(function() {
                                $(this).removeClass('slide-shown');
                            });

                            $(filterValue).addClass('slide-shown');

                            $container.slick('slickFilter', '.slide-shown');
                        } else {
                            $container.find('.jws-blog-item').each(function() {
                                $(this).removeClass('slide-shown');
                            });
                            $container.slick('slickUnfilter');
                        }

                        filterItems(filterValue);

                    }
                });
            }

            function filterItems(filterValue) {
                //use data-filter attribute & class for filtering 
                var slider = $container;
                var slide = slider.find('.jws-blog-item');

                if (filterValue == '*') {
                    // if all show all
                    slide.removeClass('hidden');
                    slide.addClass('flickity');
                } else {
                    //set active slide
                    var active = $(filterValue).removeClass('hidden');
                    // show only slide with the same class as the button "attr('data-filter')"
                    slide.addClass('flickity');
                    slide.not(active).removeClass('flickity');
                    slide.not(active).addClass('hidden');
                    // destroy slider so we can rebuild with new filters


                }
                filterAnimateComplete();
            }

            function filterAnimateComplete() {

                anime.remove('.jws-blog-item');
                anime({
                    targets: '.jws-blog-item',
                    translateX: 0,
                    opacity: 1,
                    easing: 'easeOutQuint',
                    delay: function delay() {
                        return i * 60;
                    },
                    complete: function complete(anime) {
                        $(anime.animatables).each(function(i, el) {
                            var element = $(el.target);
                            element.css({
                                transition: '',
                                transform: '',
                                opacity: ''
                            });
                        });
                    }
                });
            }

            if ($container.hasClass('jws-blog-item')) {
                filtersInit();
                postslider();

            }
        });
    };
    var blogLoadMore = function($scope, $) {
        $scope.find('.jws-blog-element').eq(0).each(function() {
            loadmore_btn($(this));

        });
    };
    var productLoadMore = function($scope, $) {
        $scope.find('.jws-products-element').eq(0).each(function() {
            loadmore_btn($(this));
        });
    };
     // Charts Handler
  var jwsChartHandler = function($scope, $) {
    var jwsChart = $scope.find(".jws-chart-container"),
      jwsChartSettings = jwsChart.data("settings"),
      type = jwsChartSettings["type"],
      eventsArray = [
        "mousemove",
        "mouseout",
        "click",
        "touchstart",
        "touchmove"
      ],
      printVal = jwsChartSettings["printVal"],
      event =
        ("pie" == type || "doughnut" == type) && printVal ? false : eventsArray,
      jwsChartData = jwsChart.data("chart"),
      data = {
        labels: jwsChartSettings["xlabels"],
        datasets: []
      };
    function renderChart() {
      var ctx = document
          .getElementById(jwsChartSettings["chartId"])
          .getContext("2d");
        

        var globalOptions = {
          maintainAspectRatio: false,
          layout: {
            padding: {
              top: type == "polarArea" ? 6 : 0
            }
          },
          events: event,
          animation: {
            duration: 500,
            easing: jwsChartSettings["easing"],
            onComplete: function() {
              if (!event) {
                this.defaultFontSize = 16;
                ctx.font =
                  '15px "Helvetica Neue", "Helvetica", "Arial", sans-serif';

                ctx.textAlign = "center";
                ctx.textBaseline = "bottom";

                this.data.datasets.forEach(function(dataset) {
                  for (var i = 0; i < dataset.data.length; i++) {
                    var model =
                        dataset._meta[Object.keys(dataset._meta)[0]].data[i]
                          ._model,
                      total =
                        dataset._meta[Object.keys(dataset._meta)[0]].total,
                      mid_radius =
                        model.innerRadius +
                        (model.outerRadius - model.innerRadius) / 2,
                      start_angle = model.startAngle,
                      end_angle = model.endAngle,
                      mid_angle = start_angle + (end_angle - start_angle) / 2;

                    var x = mid_radius * Math.cos(mid_angle);
                    var y = mid_radius * Math.sin(mid_angle);

                    ctx.fillStyle = jwsChartSettings["yTicksCol"];
                    
                    var percent =
                      String(Math.round((dataset.data[i] / total) * 100)) + "%";

                    ctx.fillText(percent, model.x + x, model.y + y + 15);
                  }
                });
              }
            }
          },
          tooltips: {
            enabled: jwsChartSettings["enTooltips"],
            mode: jwsChartSettings["modTooltips"],
            callbacks: {
              label: function(tooltipItem, data) {
                var prefixString = "";
                if (
                  "pie" == type ||
                  "doughnut" == type ||
                  "polarArea" == type
                ) {
                  prefixString = data.labels[tooltipItem.index] + ": ";
                }
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var total = dataset.data.reduce(function(
                  previousValue,
                  currentValue
                ) {
                  return parseFloat(previousValue) + parseFloat(currentValue);
                });
                var currentValue = dataset.data[tooltipItem.index];
                var percentage = ((currentValue / total) * 100).toPrecision(3);
                return (
                  prefixString +
                  (jwsChartSettings["percentage"]
                    ? percentage + "%"
                    : currentValue)
                );
              }
            }
          },
          legend: {
            display: jwsChartSettings["legDis"],
            position: jwsChartSettings["legPos"],
            reverse: jwsChartSettings["legRev"],
            onClick: null,
            labels: {
              boxWidth: parseInt(jwsChartSettings["itemWid"]),
              fontColor: jwsChartSettings["legCol"],
              fontSize: parseInt(jwsChartSettings["legSize"]),
              fontFamily:jwsChartSettings["legFamily"],
              padding:20,
            }
          }
          
        };
        
        var multiScaleOptions = {
            scales: {
            xAxes: [
              {
                barPercentage: jwsChartSettings["xwidth"],
                display:
                  type == "radar" ||
                  type == "pie" ||
                  type == "polarArea" ||
                  type == "doughnut"
                    ? false
                    : true,
                gridLines: {
                  display: jwsChartSettings["xGrid"],
                  color: jwsChartSettings["xGridCol"],
                  lineWidth: jwsChartSettings["xGridWidth"],
                  drawBorder: true
                },
                scaleLabel: {
                  display: jwsChartSettings["xlabeldis"],
                  labelString: jwsChartSettings["xlabel"],
                  fontColor: jwsChartSettings["xlabelcol"],
                  fontSize: jwsChartSettings["xlabelsize"]
                },
                ticks: {
                  fontSize: jwsChartSettings["xTicksSize"],
                  fontColor: jwsChartSettings["xTicksCol"],
                  stepSize: jwsChartSettings["stepSize"],
                  maxRotation: jwsChartSettings["xTicksRot"],
                  minRotation: jwsChartSettings["xTicksRot"],
                  beginAtZero: jwsChartSettings["xTicksBeg"],
                  callback: function(tick) {
                    return tick.toLocaleString();
                  }
                }
              }
            ],
            yAxes: [
              {
                display:
                  type == "radar" ||
                  type == "pie" ||
                  type == "polarArea" ||
                  type == "doughnut"
                    ? false
                    : true,
                type: jwsChartSettings["yAxis"],
                gridLines: {
                  display: jwsChartSettings["yGrid"],
                  color: jwsChartSettings["yGridCol"],
                  lineWidth: jwsChartSettings["yGridWidth"],
                },
                scaleLabel: {
                  display: jwsChartSettings["ylabeldis"],
                  labelString: jwsChartSettings["ylabel"],
                  fontColor: jwsChartSettings["ylabelcol"],
                  fontSize: jwsChartSettings["ylabelsize"]
                },
                ticks: {
                    suggestedMin: jwsChartSettings["suggestedMin"],
                    suggestedMax: jwsChartSettings["suggestedMax"],
                    fontSize: jwsChartSettings["yTicksSize"],
                    fontColor: jwsChartSettings["yTicksCol"],
                    beginAtZero: jwsChartSettings["yTicksBeg"],
                    stepSize: jwsChartSettings["stepSize"],
                    callback: function(tick) {
                        return tick.toLocaleString();
                    }
                }
              }
            ]
          }
      };
      
        var singleScaleOptions = {
            scale: {
                ticks: {
                    beginAtZero: jwsChartSettings["yTicksBeg"],
                    stepSize: jwsChartSettings["stepSize"],
                    suggestedMax: jwsChartSettings["suggestedMax"]
                }
            }
        };

      var myChart = new Chart(ctx, {
        type: type,
        data: data,
        options: Object.assign( globalOptions, ( "radar" !== type && "polarArea" !== type ) ? multiScaleOptions : singleScaleOptions )
      });


      jwsChartData.forEach(function(element) {
        if (type !== "pie" && type !== "doughnut") {
          var gradient = ctx.createLinearGradient(0, 0, 0, 600),
            secondColor = element.backgroundColor[1]
              ? element.backgroundColor[1]
              : element.backgroundColor[0];
          gradient.addColorStop(0, element.backgroundColor[0]);
          gradient.addColorStop(1, secondColor);
          element.backgroundColor = gradient;
          element.hoverBackgroundColor = gradient;
        }
        data.datasets.push(element);
        myChart.update();
      });

      $("#" + jwsChartSettings["chartId"]).on("click", function(evt) {
        var activePoint = myChart.getElementAtEvent(evt);
        if (activePoint[0]) {
          var URL =
            myChart.data.datasets[activePoint[0]._datasetIndex].links[
              activePoint[0]._index
            ];
          if (URL != null && URL != "") {
            window.open(URL, jwsChartSettings["target"]);
          }
        }
      });
    }
    var $checkModal = $(jwsChart).closest(".jws-modal-box-modal");

    if ($checkModal.length) {
      renderChart();
    }
    var waypoint = new Waypoint({
      element: $( "#" + jwsChartSettings["chartId"] ),
      offset: Waypoint.viewportHeight() - 250,
      triggerOnce: true,
      handler: function() {
        renderChart();
        this.destroy();
      }
    });
  };
    /**
     *-------------------------------------------------------------------------------------------------------------------------------------------
     * Google Map
     *-------------------------------------------------------------------------------------------------------------------------------------------
     */
     var WidgetjwsGoogleMapHandler = function ( $scope, $ ) {

		if ( 'undefined' == typeof $scope )
			return;

		var selector                = $scope.find( '.jws-google-map' ).eq(0),
			locations               = selector.data( 'locations' ),
			map_style               = ( selector.data( 'custom-style' ) != '' ) ? selector.data( 'custom-style' ) : '',
			predefined_style 		= ( selector.data( 'predefined-style' ) != '' ) ? selector.data( 'predefined-style' ) : '',
			info_window_size        = ( selector.data( 'max-width' ) != '' ) ? selector.data( 'max-width' ) : '',
			m_cluster            	= ( selector.data( 'cluster' ) == 'yes' ) ? true : false,
			animate            		= selector.data( 'animate' ),
			auto_center				= selector.data( 'auto-center' ),
            maker_offset				= selector.data( 'offset' ),
			map_options             = selector.data( 'map_options' ),
			i                       = '',
			bounds 					= new google.maps.LatLngBounds(),
			marker_cluster 			= [],
			device_size 			= elementorFrontend.getCurrentDeviceMode(),
            className = 'map_pin_jws';

		if( 'drop' == animate ) {
			var animation = google.maps.Animation.DROP;
		} else if( 'bounce' == animate ) {
			var animation = google.maps.Animation.BOUNCE;
		}
        
        function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }
        function CustomMarker(latlng, map, className) {
            this.latlng_ = latlng;
            this.className = className; // Once the LatLng and text are set, add the overlay to the map.  This will
            // trigger a call to panes_changed which should in turn call draw.
        
            this.setMap(map);
          }
        
          if ((typeof google === "undefined" ? "undefined" : _typeof(google)) !== _typeof(undefined) && _typeof(google.maps) !== _typeof(undefined)) {
            CustomMarker.prototype = new google.maps.OverlayView();
        
            CustomMarker.prototype.draw = function () {
              var me = this; // Check if the div has been created.
        
              var div = this.div_,
                  divChild,
                  divChild2;
        
              if (!div) {
                // Create a overlay text DIV
                div = this.div_ = document.createElement('DIV');
                div.className = this.className;
                divChild = document.createElement("div");
                div.appendChild(divChild);
                divChild2 = document.createElement("div");
                div.appendChild(divChild2);
                google.maps.event.addDomListener(div, "click", function (event) {
                  google.maps.event.trigger(me, "click");
                }); // Then add the overlay to the DOM
        
                var panes = this.getPanes();
                panes.overlayImage.appendChild(div);
              } // Position the overlay
        
        
              var point = this.getProjection().fromLatLngToDivPixel(this.latlng_);
        
              if (point) {
                div.style.left = point.x + 'px';
                div.style.top = point.y + 'px';
              }
            };
        
            CustomMarker.prototype.remove = function () {
              // Check if the overlay was on the map and needs to be removed.
              if (this.div_) {
                this.div_.parentNode.removeChild(this.div_);
                this.div_ = null;
              }
            };
        
            CustomMarker.prototype.getPosition = function () {
              return this.latlng_;
            };
          }
        
        
        
        
        

		var skins = {
			"silver" : "[{\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#f5f5f5\"}]},{\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#616161\"}]},{\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#f5f5f5\"}]},{\"featureType\":\"administrative.land_parcel\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#bdbdbd\"}]},{\"featureType\":\"poi\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#eeeeee\"}]},{\"featureType\":\"poi\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#757575\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#e5e5e5\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#9e9e9e\"}]},{\"featureType\":\"road\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#ffffff\"}]},{\"featureType\":\"road.arterial\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#757575\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#dadada\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#616161\"}]},{\"featureType\":\"road.local\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#9e9e9e\"}]},{\"featureType\":\"transit.line\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#e5e5e5\"}]},{\"featureType\":\"transit.station\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#eeeeee\"}]},{\"featureType\":\"water\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#c9c9c9\"}]},{\"featureType\":\"water\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#9e9e9e\"}]}]",

			"retro" : "[{\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#ebe3cd\"}]},{\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#523735\"}]},{\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#f5f1e6\"}]},{\"featureType\":\"administrative\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#c9b2a6\"}]},{\"featureType\":\"administrative.land_parcel\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#dcd2be\"}]},{\"featureType\":\"administrative.land_parcel\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#ae9e90\"}]},{\"featureType\":\"landscape.natural\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#dfd2ae\"}]},{\"featureType\":\"poi\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#dfd2ae\"}]},{\"featureType\":\"poi\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#93817c\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#a5b076\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#447530\"}]},{\"featureType\":\"road\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#f5f1e6\"}]},{\"featureType\":\"road.arterial\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#fdfcf8\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#f8c967\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#e9bc62\"}]},{\"featureType\":\"road.highway.controlled_access\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#e98d58\"}]},{\"featureType\":\"road.highway.controlled_access\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#db8555\"}]},{\"featureType\":\"road.local\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#806b63\"}]},{\"featureType\":\"transit.line\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#dfd2ae\"}]},{\"featureType\":\"transit.line\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#8f7d77\"}]},{\"featureType\":\"transit.line\",\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#ebe3cd\"}]},{\"featureType\":\"transit.station\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#dfd2ae\"}]},{\"featureType\":\"water\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#b9d3c2\"}]},{\"featureType\":\"water\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#92998d\"}]}]",

			"dark" : "[{\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#212121\"}]},{\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#757575\"}]},{\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#212121\"}]},{\"featureType\":\"administrative\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#757575\"}]},{\"featureType\":\"administrative.country\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#9e9e9e\"}]},{\"featureType\":\"administrative.land_parcel\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"administrative.locality\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#bdbdbd\"}]},{\"featureType\":\"poi\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#757575\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#181818\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#616161\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#1b1b1b\"}]},{\"featureType\":\"road\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#2c2c2c\"}]},{\"featureType\":\"road\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#8a8a8a\"}]},{\"featureType\":\"road.arterial\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#373737\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#3c3c3c\"}]},{\"featureType\":\"road.highway.controlled_access\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#4e4e4e\"}]},{\"featureType\":\"road.local\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#616161\"}]},{\"featureType\":\"transit\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#757575\"}]},{\"featureType\":\"water\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#000000\"}]},{\"featureType\":\"water\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#3d3d3d\"}]}]",

			"night" : "[{\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#242f3e\"}]},{\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#746855\"}]},{\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#242f3e\"}]},{\"featureType\":\"administrative.locality\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#d59563\"}]},{\"featureType\":\"poi\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#d59563\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#263c3f\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#6b9a76\"}]},{\"featureType\":\"road\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#38414e\"}]},{\"featureType\":\"road\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#212a37\"}]},{\"featureType\":\"road\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#9ca5b3\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#746855\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#1f2835\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#f3d19c\"}]},{\"featureType\":\"transit\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#2f3948\"}]},{\"featureType\":\"transit.station\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#d59563\"}]},{\"featureType\":\"water\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#17263c\"}]},{\"featureType\":\"water\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#515c6d\"}]},{\"featureType\":\"water\",\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#17263c\"}]}]",

			"aubergine" : "[{\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#1d2c4d\"}]},{\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#8ec3b9\"}]},{\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#1a3646\"}]},{\"featureType\":\"administrative.country\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#4b6878\"}]},{\"featureType\":\"administrative.land_parcel\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#64779e\"}]},{\"featureType\":\"administrative.province\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#4b6878\"}]},{\"featureType\":\"landscape.man_made\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#334e87\"}]},{\"featureType\":\"landscape.natural\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#023e58\"}]},{\"featureType\":\"poi\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#283d6a\"}]},{\"featureType\":\"poi\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#6f9ba5\"}]},{\"featureType\":\"poi\",\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#1d2c4d\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#023e58\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#3C7680\"}]},{\"featureType\":\"road\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#304a7d\"}]},{\"featureType\":\"road\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#98a5be\"}]},{\"featureType\":\"road\",\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#1d2c4d\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#2c6675\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#255763\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#b0d5ce\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#023e58\"}]},{\"featureType\":\"transit\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#98a5be\"}]},{\"featureType\":\"transit\",\"elementType\":\"labels.text.stroke\",\"stylers\":[{\"color\":\"#1d2c4d\"}]},{\"featureType\":\"transit.line\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#283d6a\"}]},{\"featureType\":\"transit.station\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#3a4762\"}]},{\"featureType\":\"water\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#0e1626\"}]},{\"featureType\":\"water\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#4e6d70\"}]}]",

			"magnesium" : "[{\"featureType\":\"all\",\"stylers\":[{\"saturation\":0},{\"hue\":\"#e7ecf0\"}]},{\"featureType\":\"road\",\"stylers\":[{\"saturation\":-70}]},{\"featureType\":\"transit\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"poi\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"water\",\"stylers\":[{\"visibility\":\"simplified\"},{\"saturation\":-60}]}]",

			"classic_blue" : "[{\"featureType\":\"all\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"administrative.country\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"administrative.country\",\"elementType\":\"labels.text\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"administrative.province\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"administrative.province\",\"elementType\":\"labels.text\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"administrative.locality\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"administrative.neighborhood\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"administrative.land_parcel\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"landscape\",\"elementType\":\"all\",\"stylers\":[{\"hue\":\"#FFBB00\"},{\"saturation\":43.400000000000006},{\"lightness\":37.599999999999994},{\"gamma\":1}]},{\"featureType\":\"landscape\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"saturation\":\"-40\"},{\"lightness\":\"36\"}]},{\"featureType\":\"landscape.man_made\",\"elementType\":\"geometry\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"landscape.natural\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"saturation\":\"-77\"},{\"lightness\":\"28\"}]},{\"featureType\":\"landscape.natural\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"poi\",\"elementType\":\"all\",\"stylers\":[{\"hue\":\"#00FF6A\"},{\"saturation\":-1.0989010989011234},{\"lightness\":11.200000000000017},{\"gamma\":1}]},{\"featureType\":\"poi\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"poi.attraction\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"saturation\":\"-24\"},{\"lightness\":\"61\"}]},{\"featureType\":\"road\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"road\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"visibility\":\"on\"}]},{\"featureType\":\"road\",\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"all\",\"stylers\":[{\"hue\":\"#FFC200\"},{\"saturation\":-61.8},{\"lightness\":45.599999999999994},{\"gamma\":1}]},{\"featureType\":\"road.highway\",\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"road.highway.controlled_access\",\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"road.arterial\",\"elementType\":\"all\",\"stylers\":[{\"hue\":\"#FF0300\"},{\"saturation\":-100},{\"lightness\":51.19999999999999},{\"gamma\":1}]},{\"featureType\":\"road.local\",\"elementType\":\"all\",\"stylers\":[{\"hue\":\"#ff0300\"},{\"saturation\":-100},{\"lightness\":52},{\"gamma\":1}]},{\"featureType\":\"road.local\",\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"transit\",\"elementType\":\"geometry\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"transit\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"transit\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"transit\",\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"transit.line\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"transit.station\",\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"water\",\"elementType\":\"all\",\"stylers\":[{\"hue\":\"#0078FF\"},{\"saturation\":-13.200000000000003},{\"lightness\":2.4000000000000057},{\"gamma\":1}]},{\"featureType\":\"water\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]}]",

			"aqua" : "[{\"featureType\":\"administrative\",\"elementType\":\"labels.text.fill\",\"stylers\":[{\"color\":\"#444444\"}]},{\"featureType\":\"landscape\",\"elementType\":\"all\",\"stylers\":[{\"color\":\"#f2f2f2\"}]},{\"featureType\":\"poi\",\"elementType\":\"all\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"road\",\"elementType\":\"all\",\"stylers\":[{\"saturation\":-100},{\"lightness\":45}]},{\"featureType\":\"road.highway\",\"elementType\":\"all\",\"stylers\":[{\"visibility\":\"simplified\"}]},{\"featureType\":\"road.arterial\",\"elementType\":\"labels.icon\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"transit\",\"elementType\":\"all\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"water\",\"elementType\":\"all\",\"stylers\":[{\"color\":\"#46bcec\"},{\"visibility\":\"on\"}]}]",

			"earth" : "[{\"featureType\":\"landscape.man_made\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#f7f1df\"}]},{\"featureType\":\"landscape.natural\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#d0e3b4\"}]},{\"featureType\":\"landscape.natural.terrain\",\"elementType\":\"geometry\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"poi\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"poi.business\",\"elementType\":\"all\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"poi.medical\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#fbd3da\"}]},{\"featureType\":\"poi.park\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#bde6ab\"}]},{\"featureType\":\"road\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"road\",\"elementType\":\"labels\",\"stylers\":[{\"visibility\":\"off\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#ffe15f\"}]},{\"featureType\":\"road.highway\",\"elementType\":\"geometry.stroke\",\"stylers\":[{\"color\":\"#efd151\"}]},{\"featureType\":\"road.arterial\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#ffffff\"}]},{\"featureType\":\"road.local\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"black\"}]},{\"featureType\":\"transit.station.airport\",\"elementType\":\"geometry.fill\",\"stylers\":[{\"color\":\"#cfb2db\"}]},{\"featureType\":\"water\",\"elementType\":\"geometry\",\"stylers\":[{\"color\":\"#a2daf2\"}]}]"
		};

		if( 'undefined' != typeof skins[predefined_style] ) {
			map_style = JSON.parse( skins[predefined_style] );
		}


		( function initMap () {

			var latlng = new google.maps.LatLng( locations[0][0], locations[0][1] );

			map_options.center = latlng;
			map_options.styles = map_style;

			if( false == map_options.gestureHandling ){
				map_options.gestureHandling = 'none';
			}

			var map = new google.maps.Map( $scope.find( '.jws-google-map' )[0], map_options );
			var infowindow = new google.maps.InfoWindow();

			for ( i = 0; i < locations.length; i++ ) {

				var title = locations[i][3];
				var description = locations[i][4];
                var images_info = locations[i][5];
				var icon_size = parseInt( locations[i][8] );
				var icon_type = locations[i][6];
				var icon = '';
				var icon_url = locations[i][7];
				var enable_iw = locations[i][2];
				var click_open = locations[i][9];
				var lat = locations[i][0];
				var lng = locations[i][1];

          
				if( 'undefined' === typeof locations[i] ) {
					return;
				}

				if ( '' != lat.length && '' != lng.length ) {

					if ( 'custom' == icon_type) {

						icon = {
							url: icon_url,
						};
						if( ! isNaN( icon_size ) ) {

							icon.scaledSize = new google.maps.Size( icon_size, icon_size );
							icon.origin = new google.maps.Point( 0, 0 );
							icon.anchor = new google.maps.Point( icon_size/2, icon_size );

						}
                        var marker = new google.maps.Marker( {
    						position:       new google.maps.LatLng( lat, lng ),
    						map:            map,
    						title:          title,
    						icon:           icon,
    						animation: 		animation
    					});
					}else if('html' == icon_type){
					   marker = new CustomMarker(new google.maps.LatLng( lat, lng ), map, className);
					}else {
					   var marker = new google.maps.Marker( {
    						position:       new google.maps.LatLng( lat, lng ),
    						map:            map,
    						title:          title,
    						icon:           icon,
    						animation: 		animation
    					});
					}
                    if('undefined' !== typeof maker_offset) {
                     map.panBy(0,maker_offset); 
                    }
                    
                    

					if( locations.length > 1 ) {

						// Extend the bounds to include each marker's position
						bounds.extend( marker.position );
					}

					marker_cluster[i] = marker;

					if ( enable_iw && 'iw_open' == click_open ) {
                        var has_image = '';
                        if(images_info != '') { 
                            has_image = ' has-image';
                        }
                        
						var content_string = '<div class="jws-infowindow-content'+has_image+'"><div class="info-left"><div class="jws-infowindow-title">' + title + '</div>';

						if ( '' != description.length ) {
							content_string += '<div class="jws-infowindow-description">' + description + '</div></div>';
						}
                        
                        if(images_info != '') {
                           content_string += '<div class="info-right"><img src="'+images_info+'"></div>'; 
                        }
                        
						content_string += '</div>';

						if ( '' != info_window_size  ) {
							var width_val = parseInt( info_window_size );
							var infowindow = new google.maps.InfoWindow( {
								content: content_string,
								maxWidth: width_val
							} );
						} else {
							var infowindow = new google.maps.InfoWindow( {
								content: content_string,
							} );
						}


						infowindow.open( map, marker );
					}

					// Adding close event for info window
					google.maps.event.addListener( map, 'click', ( function ( infowindow ) {

						return function() {
							infowindow.close();
						}
					})( infowindow ));

					if ( enable_iw && '' != locations[i][3] ) {

						google.maps.event.addListener( marker, 'click', ( function( marker, i ) {
							return function() {
								var infowindow = new google.maps.InfoWindow();
								var content_string = '<div class="jws-infowindow-content"><div class="jws-infowindow-title">' + locations[i][3] + '</div>';

								if ( '' != locations[i][4].length ) {
									content_string += '<div class="jws-infowindow-description">' + locations[i][4] + '</div>';
								}

								content_string += '</div>';

								infowindow.setContent( content_string );

								if ( '' != info_window_size ) {
									var width_val = parseInt( info_window_size );
									var InfoWindowOptions = { maxWidth : width_val };
									infowindow.setOptions( { options:InfoWindowOptions } );
								}

								infowindow.open( map, marker );
							}
						})( marker, i ));
					}
				}
			}

			if( locations.length > 1 ) {

				if ( 'center' == auto_center ) {

					// Now fit the map to the newly inclusive bounds.
					map.fitBounds( bounds );
				}

				// Restore the zoom level after the map is done scaling.
				var listener = google.maps.event.addListener( map, "idle", function () {
					map.setZoom( map_options.zoom );
					google.maps.event.removeListener( listener );
				});
			}

		})(); 
	}

})(jQuery);