var jwsWooShopModule;

(function($) {
    "use strict";
    jwsWooShopModule = (function() {
        return {
            init: function() {
                this.filter_product();
                this.woocommerceOrdering();
                this.wcInitSwitchLayout();
                this.productPriceFilter();
                this.initProductMasonry(),
                    this.filter_product_moblie();
                this.productsLoadMore();

            },
            /*------------------------
              Filter shop sidebar
             -------------------------*/
            woocommerceOrdering: function() {
                var shop_filter = {
                    class_filter: 'jws_wc_filter_layout a, .product-categories a , .woocommerce-ordering a , .product-categories a , .widget_layered_nav a , .wc-layered-nav-rating a , .widget_layered_nav_filters a , .jws-remove-filters',
                    scroll: 'jws_wc_filter_layout a, .product-categories a , .woocommerce-ordering a , .product-categories a , .widget_layered_nav a , .wc-layered-nav-rating a , .price_slider_amount .button , .widget_layered_nav_filters ul li a',
                };
                var filters = $('.woocommerce-ordering ul'),
                    time = 200;
                $('body').on('click', '.woocommerce-ordering .current', function() {

                    if (isOpened()) {
                        closeFilters();
                    } else {
                        filters.stop().slideDown(time);
                        $('.woocommerce-ordering .current').addClass('showed');
                        setTimeout(function() {
                            filters.addClass('showed');
                        }, time);
                    }

                });
                $('body').on('click', shop_filter.class_filter, function() {
                    if (isOpened()) {
                        closeFilters();
                    }
                });

                $('body').on('click', '.open-filters', function() {
                    if (isOpened()) {
                        closeFilters();
                    }
                });
                var isOpened = function() {
                    filters = $('.woocommerce-ordering ul');
                    return filters.hasClass('showed');
                };
                var closeFilters = function() {
                    filters = $('.woocommerce-ordering ul');
                    filters.removeClass('showed');
                    filters.stop().slideUp(time);
                    $('.woocommerce-ordering .current').removeClass('showed');
                };
            },
            filter_product: function() {

                $(document).on('click', '.widget_price_filter form .button', function(e) {
                    e.preventDefault();
                    var form = $('.price_slider').closest('form').get(0),
                        $form = $(form),
                        url = $form.attr('action') + '?' + $form.serialize();

                    $(document.body).trigger('jws_catelog_filter_ajax', url, $(this));
                });



                $(document.body).find('#jws-shop-product-cats').on('click', '.cat-link', function(e) {
                    e.preventDefault();
                    var url = $(this).attr('href');
                    $(document.body).trigger('jws_catelog_filter_ajax', url, $(this));
                });

                $(document.body).find('#jws-shop-toolbar').find('.woocommerce-ordering').on('click', 'a', function(e) {
                    e.preventDefault();
                    $(this).addClass('active');
                    var url = $(this).attr('href');
                    $(document.body).trigger('jws_catelog_filter_ajax', url, $(this));
                });

                $(document.body).find('#jws-categories-filter').on('click', 'a', function(e) {
                    e.preventDefault();
                    $(this).addClass('selected');
                    var url = $(this).attr('href');
                    $(document.body).trigger('jws_catelog_filter_ajax', url, $(this));

                });

                $(document.body).find('.dropdown_product_cat').on('change', function() {
                    var input_url = $('input[name=url-get]').val();
                    var url;
                    if ($(this).val() != '') {
                        url = window.location.href.split('?')[0] + '?product_cat=' + $(this).val() + input_url;
                        location.href = url;
                    } else {
                        location.href = window.location.href.split('?')[0] + '?' + input_url;
                    }
                });
                $(document.body).find('#jws-shop-topbar, .shop-sidebar').on('click', 'a', function(e) {
                    var $widget = $(this).closest('.widget');
                    if ($widget.hasClass('widget_product_tag_cloud') ||
                        $widget.hasClass('widget_product_categories') ||
                        $widget.hasClass('widget_layered_nav_filters') ||
                        $widget.hasClass('widget_layered_nav') ||
                        $widget.hasClass('product-sort-by') ||
                        $widget.hasClass('jws-price-filter-list')) {
                        e.preventDefault();
                        $(this).closest('li').addClass('chosen');
                        var input_url = $('input[name=url-get]').val();
                        var url;
                        if ($(this).attr('href').indexOf('?') >= 1) {
                            url = $(this).attr('href') + input_url;
                        } else {
                            url = $(this).attr('href') + '?' + input_url;
                        }
                        $(document.body).trigger('jws_catelog_filter_ajax', url, $(this));
                    }

                    if ($widget.hasClass('widget_product_tag_cloud')) {
                        $(this).addClass('selected');
                    }

                    if ($widget.hasClass('product-sort-by')) {
                        $(this).addClass('active');
                    }
                });

                $(document.body).on('jws_catelog_filter_ajax', function(e, url, element) {

                    var $container = $('.shop-content'),
                        $container_nav = $('.shop-sidebar'),
                        $categories = $('#jws-categories-filter'),
                        $shopTopbar = $('#jws-shop-topbar'),
                        intervalID,
                        $ordering = $('.shop-toolbar .woocommerce-ordering');
                    if ($('.shop-content').length > 0) {
                        var position = $('.shop-content').offset().top - 200;
                        $('html, body').stop().animate({
                                scrollTop: position
                            },
                            1200
                        );
                    }

                    clearInterval(intervalID);
                    $('.jws_woo_main_products, .jws-products-element').addClass('jws-animated-products jws-animated-products-filter');
                    $('.jws_woo_loader').addClass('show');
                    if ('?' == url.slice(-1)) {
                        url = url.slice(0, -1);
                    }

                    url = url.replace(/%2C/g, ',');

                    history.pushState(null, null, url);

                    $(document.body).trigger('jws_ajax_filter_before_send_request', [url, element]);



                    $.get(url, function(res) {
                        
                        
                        $container_nav.find('.widget').each(function(){
                            if(!$(this).hasClass('widget_shopping_cart')) {
                              $(this).html($(res).find('#'+$(this).attr('id')).html());  
                            }	
            			})
                        
                        
                        
                        
                        $container.replaceWith($(res).find('.shop-content'));
                        //$container_nav.html($(res).find('.shop-sidebar').html());
                        $categories.html($(res).find('#jws-categories-filter').html());
                        $shopTopbar.html($(res).find('#jws-shop-topbar').html());
                        $ordering.html($(res).find('.shop-toolbar .woocommerce-ordering').html());
                        $('.jws_woo_loader').removeClass('show');
                        jwsWooShopModule.initProductMasonry();
                        jwsWooShopModule.productPriceFilter();
      
                        jwsWooShopModule.productsLoadMore();
                        
                        
                         var data = {};
                        jQuery.post(
                        wc_cart_fragments_params.wc_ajax_url.toString().replace( '%%endpoint%%', 'get_refreshed_fragments' ), data,
                        function( response ){
                                var fragments = response.fragments;
                                  // Replace fragments
                                        if (fragments) {
                                            $.each(fragments, function(key, value) {
                                                //$(key).replaceWith(value);
                                            });
                                        }
                        })
                
                       
                        
                        
                        
                        var iter = 0;
                        $('.product-item').addClass('animated-global');
                        intervalID = setInterval(function() {
                            $('.product-item').eq(iter).addClass('jws-animated');
                            iter++;
                        }, 100);
                    
                        $('#jws-shop-loading').removeClass('show');
                        $(document.body).trigger('jws_ajax_filter_request_success', [res, url]);

                    }, 'html');


                });

                $(document.body).on('jws_ajax_filter_before_send_request', function() {
                    if ($('#jws-shop-toolbar').hasClass('on-mobile') || $('#jws-shop-topbar').hasClass('on-mobile')) {
                        $('#jws-shop-topbar').slideUp();
                        $('#jws-toggle-cats-filter').removeClass('active');
                        $('.jws-filter').removeClass('active');
                    }
                });



            },

            // Call Filter Shop

            productPriceFilter: function() {
                // woocommerce_price_slider_params is required to continue, ensure the object exists
                if (typeof woocommerce_price_slider_params === 'undefined' || $('.price_slider_amount #min_price').length < 1 || !$.fn.slider) {
                    return false;
                }

                var $slider = $('.price_slider');

                if ($slider.slider('instance') !== undefined) return;

                // Get markup ready for slider
                $('input#min_price, input#max_price').hide();
                $('.price_slider, .price_label').show();

                // Price slider uses jquery ui
                var min_price = $('.price_slider_amount #min_price').data('min'),
                    max_price = $('.price_slider_amount #max_price').data('max'),
                    current_min_price = parseInt(min_price, 10),
                    current_max_price = parseInt(max_price, 10);

                if ($('.jws_woo_loader_price').attr('data-min_price') && $('.jws_woo_loader_price').attr('data-min_price').length > 0) {
                    current_min_price = parseInt($('.jws_woo_loader_price').attr('data-min_price'), 10);
                }
                if ($('.jws_woo_loader_price').attr('data-max_price') && $('.jws_woo_loader_price').attr('data-max_price').length > 0) {
                    current_max_price = parseInt($('.jws_woo_loader_price').attr('data-max_price'), 10);
                }

                $slider.slider({
                    range: true,
                    animate: true,
                    min: min_price,
                    max: max_price,
                    values: [current_min_price, current_max_price],
                    create: function() {

                        $('.price_slider_amount #min_price').val(current_min_price);
                        $('.price_slider_amount #max_price').val(current_max_price);

                        $(document.body).trigger('price_slider_create', [current_min_price, current_max_price]);
                    },
                    slide: function(event, ui) {

                        $('input#min_price').val(ui.values[0]);
                        $('input#max_price').val(ui.values[1]);

                        $(document.body).trigger('price_slider_slide', [ui.values[0], ui.values[1]]);
                    },
                    change: function(event, ui) {

                        $(document.body).trigger('price_slider_change', [ui.values[0], ui.values[1]]);
                    }
                });

                setTimeout(function() {
                    $(document.body).trigger('price_slider_create', [current_min_price, current_max_price]);
                }, 10);
            },

            productsLoadMore: function() {
                // Shop Page
                $(document.body).on('click', '#jws-shop-infinite-loading a.next, .jws_product_pagination .jws-products-load-more', function(e) {
                    e.preventDefault();

                    if ($(this).data('requestRunning')) {
                        return;
                    }

                    $(this).data('requestRunning', true);
                    $('.woocommerce-pagination, .jws_product_pagination').addClass('loading');
                    var $products = $('.products'),
                        intervalID,
                        $pagination = $(this).closest('.woocommerce-pagination, .jws_product_pagination');

                    clearInterval(intervalID);
                    $('.jws_woo_main_products, .jws-products-element').addClass('jws-animated-products jws-animated-products-loading');
                    $.get(
                        $(this).attr('href'),
                        function(response) {

                            var content = $(response).find('.products').children('.product-item'),
                                $pagination_html = $(response).find('.woocommerce-pagination, .jws_product_pagination').html();


                            $pagination.html($pagination_html);
                            $products.append(content);
                            $pagination.find('.page-numbers.next').data('requestRunning', false);
                            if ($('.product-list').hasClass('jws-masonry')) {
                                $products.isotope('insert', content);
                            }
                            $(document.body).trigger('jws_shop_ajax_loading_success');
                            var iter = 0;
                            content.addClass('animated-global');
                            intervalID = setInterval(function() {
                                content.eq(iter).addClass('jws-animated');
                                iter++;
                            }, 100);

                            if (!$pagination.find('li .page-numbers').hasClass('next')) {
                                $pagination.addClass('loaded');
                            }
                        }
                    );
                });

                // Shop loading suceess
                $(document.body).on('jws_shop_ajax_loading_success', function() {
                    $('.woocommerce-pagination, .jws_product_pagination').removeClass('loading');
                    jwsWooShopModule.initProductMasonry();
                });
            },
            initProductMasonry: function() {
                if ($('.product-list').hasClass('jws-masonry')) {
                    var el = $('.jws-masonry');
                    el.each(function(i, val) {
                        var _option = $(this).data('masonry-product');

                        if (_option !== undefined) {
                            var _selector = _option.selector,
                                _width = _option.columnWidth;
                            $(this).imagesLoaded(function() {
                                $(val).isotope({
                                    layoutMode: 'packery',
                                    itemSelector: _selector,
                                    percentPosition: true,
                                    transitionDuration: "0.3s",
                                    masonry: {
                                        columnWidth: _width
                                    }
                                });
                            });

                        }
                    });
                }

            },
            wcInitSwitchLayout: function() {
                $('body').on('click', '.jws_wc_columns_view .column_item a',function(e, url, element) {
                    e.preventDefault();
                    var _this = $(this).parent(),
                        _parent = _this.closest('.jws_wc_columns_view');


                    _parent.find('.column_item').removeClass('active');
                    _this.addClass('active');
					var $products = $('.shop-content .product-shop-listing'),
						intervalID,
                        url =$(this).attr('href'),
						$pagination = $(this).closest('.woocommerce-pagination, .jws_product_pagination');

					clearInterval(intervalID);
                        if ('?' == url.slice(-1)) {
                        url = url.slice(0, -1);
                    }

                    url = url.replace(/%2C/g, ',');

                    history.pushState(null, null, url);

                    
                       
					$('.jws_woo_main_products, .jws-products-element').addClass('jws-animated-products jws-animated-products-loading');
					$.get(
						$(this).attr('href'),
						function(response) {      
							var content = $(response).find('.product-shop-listing');
							$products.html(content);
                            
                            var iter = 0;
                            $('.product-item').addClass('animated-global');
                            intervalID = setInterval(function() {
                                $('.product-item').eq(iter).addClass('jws-animated');
                                iter++;
                            }, 100);
						}
					);


                });
               
            },
            /******************************FILTER PRODUCT MOBLIE************************************************/
            filter_product_moblie: function() {
                $(document).on('click', '#filter-button', function() {
                    $('body').append('<div class="mfp-bg quick-view-main mfp-ready"></div>');
                    $('body').append('<div class="close-popup"><i aria-hidden="true" class="eva eva-close"></i></div>');
                    $('.shop-sidebar').addClass('active');
                });

                $(document).on('click', '.close-popup', function() {
                    $('body .mfp-bg').remove();
                    $('.shop-sidebar').removeClass('active');
                    $(this).remove();
                });
            },
        };
    }());

})(jQuery);
jQuery(document).ready(function() {

    jwsWooShopModule.init();

});