<?php



/*
* Function ajax tab
*/
if (!function_exists('jws_ajax_blog_tab')) {
    function jws_ajax_blog_tab()
    {
               $settings = array('blog_ids','blogs_layouts','tab_categories','blog_attribute','posts_per_page','orderby','order','attribute_value','blog_tag','readmore_text','excerpt_length','excerpt_more','blog_image_size');
        if (isset($_POST['blog_ids'])) {
            $settings['blog_ids'] = sanitize_text_field(wp_unslash($_POST['blog_ids']));
        }
        if (isset($_POST['blogs_layouts'])) {
            $settings['blogs_layouts'] = sanitize_text_field($_POST['blogs_layouts']);
        }
        if (isset($_POST['tab_categories'])) {
            $settings['tab_categories'] = sanitize_text_field($_POST['tab_categories']);
        }
        if (isset($_POST['posts_per_page'])) {
            $settings['posts_per_page'] = intval($_POST['posts_per_page']);
        }
        if (isset($_POST['orderby'])) {
            $settings['orderby'] = sanitize_text_field($_POST['orderby']);
        }
        if (isset($_POST['order'])) {
            
            $settings['order'] = strtoupper(sanitize_text_field($_POST['order']));
        }
        if (isset($_POST['readmore_text'])) {
            
            $settings['readmore_text'] = strtoupper(sanitize_text_field($_POST['readmore_text']));
        }
        if (isset($_POST['excerpt_length'])) {
            
            $settings['excerpt_length'] = strtoupper(sanitize_text_field($_POST['excerpt_length']));
        }
        if (isset($_POST['excerpt_more'])) {
            
            $settings['excerpt_more'] = strtoupper(sanitize_text_field($_POST['excerpt_more']));
        }
         if (isset($_POST['blog_image_size'])) {
            
            $settings['blog_image_size'] = strtoupper(sanitize_text_field($_POST['blog_image_size']));
        }
        if (is_front_page()) {
            $paged = (get_query_var('page')) ? get_query_var('page') : 1;
        } else {
            $paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
        }
        $class_row = 'blogs blog-content ';
        if($_POST['layout'] == 'grid'){
            $class_row    .= 'grid-layout row';
            $grid_class = 'blog-item '.$_POST['display'].' col-xl-' . $_POST['columns'] . ' col-lg-' . $_POST['columns_tablet'] . ' col-' . $_POST['columns_mobile'] .'';
        }else {
             $class_row .= 'slider-layout carousel';   
             $grid_class = 'blog-item '.$_POST['display'].'';
        }
        
        $class_row .= ' jws_blogs_'.$_POST['blogs_layouts'].'';
        $class_row .= ' jws_pagination_'.$_POST['pagination_type'].' ';
        
        $blog_attr = array(
            'post_type' => 'post',
            'posts_per_page' =>  $settings['posts_per_page'],
            'paged' =>  $paged,
            'orderby' =>  $settings['orderby'],
            'order' =>  $settings['order'],
            'post__not_in'=>  $settings['blog_ids'],
        );
        $blog_attr['tax_query'][] = [
						'taxonomy' => 'category',
						'field'    => 'slug',
						'terms'    =>  $settings['tab_categories'],
                        'operator' => 'IN'
					];

     
            if (is_array($settings['blog_attribute'])) {
                foreach ($settings['blog_attribute'] as $key => $value) {
                    $tax_query[] = array(
                        'taxonomy' => $value,
                        'terms'    => array_map('sanitize_title', (array)$settings['attribute_value'][$key]),
                        'field'    => 'slug',
                        'operator' => 'IN'
                    );
                }
            } else {
                $tax_query[] = array(
                    'taxonomy' => sanitize_title($settings['blog_attribute']),
                    'terms'    => array_map('sanitize_title', (array)$settings['attribute_value']),
                    'field'    => 'slug',
                    'operator' => 'IN'
                );
            }
        

        if (isset($settings['blog_tag'])) {
            $blog_attr['blog_tag'] = sanitize_title($settings['blog_tag']);
        }



        if (isset($_POST['s']) && $_POST['s'] != '') {
            $blog_attr['s'] = esc_attr($_POST['s']);
        }

        $blog_query = new WP_Query($blog_attr);
        ob_start(); ?>
        <div>
        <div class="<?php echo esc_attr($class_row); ?>">

            <?php while ($blog_query->have_posts()) {
            $blog_query->the_post();
             $class_slug = '';
                $format = has_post_format() ? get_post_format() : 'no_format'; 
                echo '<article class="'.$grid_class.' '.$format.$class_slug.'">';
                       include JWS_ABS_PATH . '/inc/elementor_widget/widgets/blog_tabs/layout/'.$settings['blogs_layouts'].'.php';
                       
                echo '</article>';
         
        } ?>
        </div>
        </div>
        <?php
        $output = ob_get_contents();
        ob_end_clean();
        wp_reset_postdata();
        echo ent2ncr($output);
    }

    add_action('wp_ajax_jws_ajax_blog_tab', 'jws_ajax_blog_tab');
    add_action('wp_ajax_nopriv_jws_ajax_blog_tab', 'jws_ajax_blog_tab');
}