<?php


add_image_size( 'size-270x340',270,340, true );
function isfont($arr){
    $value= false;
    $font_family = false;
    $font_size = false;
    $line_height = false;
    $font_weight = false;
	if(!empty($arr['font-family'])) {
	   $font_family = true;
	}
    if(!empty($arr['font-size'])) {
	   $font_size = true;
	}
    if(!empty($arr['font-weight'])) {
	   $font_weight = true;
	}
    if(!empty($arr['line-height'])) {
	   $line_height = true;
	}
    if($font_family== true && $font_size== true && $line_height== true && $font_weight== true ){
        $value = true;
    }
    return $value;
}

add_filter( 'pre_option_default_category', '__return_empty_string', 999 );
function limit_post() {
    global $wp_query;
    global $jws_option;
   $current_term = $wp_query->get_queried_object();

    $post_per_page = isset($jws_option['shows_per_page']) && $jws_option['shows_per_page'] ? $jws_option['shows_per_page'] : 8 ; 
if ( ( ! is_admin() && $wp_query->is_main_query() && is_post_type_archive( 'shows' ) ) || ( is_tax() && ( isset( $current_term->taxonomy ) && $current_term->taxonomy =='shows_cat'   ) )) {
    $wp_query->set( 'posts_per_page', $post_per_page );
}
}
add_action( 'pre_get_posts', 'limit_post' );

/**
 * Prealoading
 *
 * @return string
 */
 if (!function_exists('jws_loading')) {
    function jws_loading()
    {

    global $jws_option;
    $loadingimg = (isset($jws_option['logo_loading']) && $jws_option['logo_loading']) ? $jws_option['logo_loading'] : '';
    $loadingtext = (isset($jws_option['logo_text_loading']) && $jws_option['logo_text_loading']) ? $jws_option['logo_text_loading'] : '';
        if((isset($jws_option['loading']) && $jws_option['loading']) && !empty($loadingimg) ) :
        
     ?>
    <div class="jws-preloading">
        <div class="loading_logo">
        <?php
        $image = $loadingimg['url'];
            	if( substr($loadingimg['url'], -3, 3) == 'svg' ) {
				       WP_Filesystem();
                     global $wp_filesystem;
					if( preg_match( '/^\d+$/', $image ) ){
        				$images = jws_include_svg( $image );
        			}
        			else {
        				$images = $image;
        			} 
                    ?> <span class="svg_icon"> <?php
        			
                echo wp_kses_post($wp_filesystem->get_contents( $images ));
       
                     ?></span><?php
				} 
         ?>
          
            <span class="animation_loading_js"></span>
            <span class="logo-text-loading"><?php echo esc_html($loadingtext); ?></span>
        </div>
    </div>
    <?php endif;
    }
    add_action('wp_head', 'jws_loading', 1);
} 



/**
 * Render header layout.
 *
 * @return string
 */
if (!function_exists('jws_header')) {
    function jws_header()
    {
        global $jws_option;
        
        
        ob_start();
        if(isset($jws_option['select-header']) && !empty($jws_option['select-header'])) {
          get_template_part('template-parts/header/header');  
        }else {
          get_template_part('template-parts/header/header_none');  
        }
        
        $output = ob_get_clean();
        echo apply_filters('jws_header', $output);
    }
}
// **********************************************************************// 
// ! Add favicon 
// **********************************************************************// 
if (!function_exists('jws_favicon')) {
    function jws_favicon()
    {

        if (function_exists('has_site_icon') && has_site_icon()) return '';

        $favicon = '';

        global $jws_option;
        
        if(isset($jws_option['favicon']) && !empty($jws_option['favicon'])) {
            $favicon = $jws_option['favicon']['url'];
                ?>
                    <link rel="shortcut icon" href="<?php echo esc_attr($favicon); ?>">
                    <link rel="apple-touch-icon-precomposed" sizes="152x152" href="<?php echo esc_attr($favicon); ?>">
                <?php
        }
    
    }

    add_action('wp_head', 'jws_favicon', 1);
}
/**
 * Render footer layout.
 *
 * @return string
 */
if (!function_exists('jws_footer')) {
    function jws_footer()
    {
        global $jws_option;
        
        
        ob_start();
        if(isset($jws_option['select-footer']) && !empty($jws_option['select-footer'])) {
          get_template_part('template-parts/footer/footer');  
        }else {
          get_template_part('template-parts/footer/footer_none');  
        }
        
        $output = ob_get_clean();
        echo apply_filters('footer', $output);
    }
}

/**
* Get post title by ID
*
* @since 1.1.0
*/
function get_posts_title_by_id() {

		$ids = isset( $_POST['id'] ) ? $_POST['id'] : array();

		$results = [];

		$query = new \WP_Query(
			[
				'post_type'      => 'any',
				'post__in'       => $ids,
				'posts_per_page' => -1,
			]
		);

		foreach ( $query->posts as $post ) {
			$results[ $post->ID ] = $post->post_title;
		}

		// return the results in json.
		wp_send_json( $results );
	}  
    
    
    	/**
	 * Get post by search
	 *
	 * @since 1.1.0
	 */
	function get_posts_by_query() {

		$search_string = isset( $_POST['q'] ) ? sanitize_text_field( $_POST['q'] ) : '';
		$req_post_type = isset( $_POST['post_type'] ) ? sanitize_text_field( $_POST['post_type'] ) : 'all';

		$data   = array();
		$result = array();

		$args = array(
			'public'   => true,
			'_builtin' => false,
		);

		$output   = 'names'; // names or objects, note names is the default.
		$operator = 'and'; // also supports 'or'.

		if ( 'all' === $req_post_type ) {
			$post_types = get_post_types( $args, $output, $operator );

			$post_types['Posts'] = 'post';
			$post_types['Pages'] = 'page';
		} else {
			$post_types[ $req_post_type ] = $req_post_type;
		}

		foreach ( $post_types as $key => $post_type ) {

			$data = array();


			$query = new \WP_Query(
				array(
					's'              => $search_string,
					'post_type'      => $post_type,
					'posts_per_page' => - 1,
				)
			);

			if ( $query->have_posts() ) {
				while ( $query->have_posts() ) {
					$query->the_post();
					$title  = get_the_title();
					$title .= ( 0 != $query->post->post_parent ) ? ' (' . get_the_title( $query->post->post_parent ) . ')' : '';
					$id     = get_the_id();
					$data[] = array(
						'id'   => $id,
						'text' => $title,
					);
				}
			}

			if ( is_array( $data ) && ! empty( $data ) ) {
				$result[] = array(
					'text'     => $key,
					'children' => $data,
				);
			}
		}

		$data = array();

		wp_reset_postdata();

		// return the result in json.
		wp_send_json( $result );
	}  
    
    	/**
	 * Return search results only by post title.
	 * This is only run from get_posts_by_query()
	 *
	 * @param  (string)   $search   Search SQL for WHERE clause.
	 * @param  (WP_Query) $wp_query The current WP_Query object.
	 *
	 * @return (string) The Modified Search SQL for WHERE clause.
	 */
	function search_only_titles( $search, $wp_query ) {
		if ( ! empty( $search ) && ! empty( $wp_query->query_vars['search_terms'] ) ) {
			global $wpdb;

			$q = $wp_query->query_vars;
			$n = ! empty( $q['exact'] ) ? '' : '%';

			$search = array();

			foreach ( (array) $q['search_terms'] as $term ) {
				$search[] = $wpdb->prepare( "$wpdb->posts.post_title LIKE %s", $n . $wpdb->esc_like( $term ) . $n );
			}

			if ( ! is_user_logged_in() ) {
				$search[] = "$wpdb->posts.post_password = ''";
			}

			$search = ' AND ' . implode( ' AND ', $search );
		}

		return $search;
	}
    
add_action( 'wp_ajax_jws_get_posts_by_query', 'get_posts_by_query');
add_action( 'wp_ajax_jws_get_posts_title_by_id', 'get_posts_title_by_id' );

/** Add Function Crop Images   **/
function jws_getImageBySize($params = array())
{
    $params = array_merge(array(
        'post_id' => null,
        'attach_id' => null,
        'thumb_size' => 'thumbnail',
        'class' => '',
    ), $params);

    if (!$params['thumb_size']) {
        $params['thumb_size'] = 'thumbnail';
    }

    if (!$params['attach_id'] && !$params['post_id']) {
        return false;
    }

    $post_id = $params['post_id'];

    $attach_id = $post_id ? get_post_thumbnail_id($post_id) : $params['attach_id'];
    $attach_id = apply_filters('jws_object_id', $attach_id);
    $thumb_size = $params['thumb_size'];
    $thumb_class = (isset($params['class']) && '' !== $params['class']) ? $params['class'] . ' ' : '';

    global $_wp_additional_image_sizes;
    $thumbnail = '';
    $urlcrop = '';
    if (is_string($thumb_size) && ((!empty($_wp_additional_image_sizes[$thumb_size]) && is_array($_wp_additional_image_sizes[$thumb_size])) || in_array($thumb_size, array(
                'thumbnail',
                'thumb',
                'medium',
                'large',
                'full',
            )))
    ) {
        $attributes = array('class' => $thumb_class . 'attachment-' . $thumb_size);
        $thumbnail = wp_get_attachment_image($attach_id, $thumb_size, false, $attributes);
    } elseif ($attach_id) {
        if (is_string($thumb_size)) {
            preg_match_all('/\d+/', $thumb_size, $thumb_matches);
            if (isset($thumb_matches[0])) {
                $thumb_size = array();
                $count = count($thumb_matches[0]);
                if ($count > 1) {
                    $thumb_size[] = $thumb_matches[0][0]; // width
                    $thumb_size[] = $thumb_matches[0][1]; // height
                } elseif (1 === $count) {
                    $thumb_size[] = $thumb_matches[0][0]; // width
                    $thumb_size[] = $thumb_matches[0][0]; // height
                } else {
                    $thumb_size = false;
                }
            }
        }
        if (is_array($thumb_size)) {
            // Resize image to custom size
            $p_img = wpb_resize2($attach_id, null, $thumb_size[0], $thumb_size[1], true);
            $alt = trim(strip_tags(get_post_meta($attach_id, '_wp_attachment_image_alt', true)));
            $attachment = get_post($attach_id);
            if (!empty($attachment)) {
                $title = trim(strip_tags($attachment->post_title));

                if (empty($alt)) {
                    $alt = trim(strip_tags($attachment->post_excerpt)); // If not, Use the Caption
                }
                if (empty($alt)) {
                    $alt = $title;
                } // Finally, use the title
                if ($p_img) {

                    $attributes = jws_stringify_attributes(array(
                        'class' => $thumb_class,
                        'src' => $p_img['url'],
                        'width' => $p_img['width'],
                        'height' => $p_img['height'],
                        'alt' => $alt,
                        'title' => $title,
                    ));
                    $urlcrop = $p_img['url'];
                    $thumbnail = '<img ' . $attributes . ' />';
                }
            }
        }
    }

    $p_img_large = wp_get_attachment_image_src($attach_id, 'large');

    return apply_filters('jws_wpb_getimagesize', array(
        'thumbnail' => $thumbnail,
        'p_img_large' => $p_img_large,
        'url_crop' => $urlcrop,
    ), $attach_id, $params);
}

if (!function_exists('wpb_resize2')) {
    /**
     * @param int $attach_id
     * @param string $img_url
     * @param int $width
     * @param int $height
     * @param bool $crop
     *
     * @since 4.2
     * @return array
     */
    function wpb_resize2($attach_id = null, $img_url = null, $width, $height, $crop = false)
    {
        // this is an attachment, so we have the ID
        $image_src = array();
        if ($attach_id) {
            $image_src = wp_get_attachment_image_src($attach_id, 'full');
            $actual_file_path = get_attached_file($attach_id);
            // this is not an attachment, let's use the image url
        } elseif ($img_url) {
            $file_path = parse_url($img_url);
            $actual_file_path = rtrim(ABSPATH, '/') . $file_path['path'];
            $orig_size = getimagesize($actual_file_path);
            $image_src[0] = $img_url;
            $image_src[1] = $orig_size[0];
            $image_src[2] = $orig_size[1];
        }
        if (!empty($actual_file_path)) {
            $file_info = pathinfo($actual_file_path);
            $extension = '.' . $file_info['extension'];

            // the image path without the extension
            $no_ext_path = $file_info['dirname'] . '/' . $file_info['filename'];

            $cropped_img_path = $no_ext_path . '-' . $width . 'x' . $height . $extension;

            // checking if the file size is larger than the target size
            // if it is smaller or the same size, stop right here and return
            if ($image_src[1] > $width || $image_src[2] > $height) {

                // the file is larger, check if the resized version already exists (for $crop = true but will also work for $crop = false if the sizes match)
                if (file_exists($cropped_img_path)) {
                    $cropped_img_url = str_replace(basename($image_src[0]), basename($cropped_img_path), $image_src[0]);
                    $vt_image = array(
                        'url' => $cropped_img_url,
                        'width' => $width,
                        'height' => $height,
                    );

                    return $vt_image;
                }

                if (false == $crop) {
                    // calculate the size proportionaly
                    $proportional_size = wp_constrain_dimensions($image_src[1], $image_src[2], $width, $height);
                    $resized_img_path = $no_ext_path . '-' . $proportional_size[0] . 'x' . $proportional_size[1] . $extension;

                    // checking if the file already exists
                    if (file_exists($resized_img_path)) {
                        $resized_img_url = str_replace(basename($image_src[0]), basename($resized_img_path), $image_src[0]);

                        $vt_image = array(
                            'url' => $resized_img_url,
                            'width' => $proportional_size[0],
                            'height' => $proportional_size[1],
                        );

                        return $vt_image;
                    }
                }

                // no cache files - let's finally resize it
                $img_editor = wp_get_image_editor($actual_file_path);

                if (is_wp_error($img_editor) || is_wp_error($img_editor->resize($width, $height, $crop))) {
                    return array(
                        'url' => '',
                        'width' => '',
                        'height' => '',
                    );
                }

                $new_img_path = $img_editor->generate_filename();

                if (is_wp_error($img_editor->save($new_img_path))) {
                    return array(
                        'url' => '',
                        'width' => '',
                        'height' => '',
                    );
                }
                if (!is_string($new_img_path)) {
                    return array(
                        'url' => '',
                        'width' => '',
                        'height' => '',
                    );
                }

                $new_img_size = getimagesize($new_img_path);
                $new_img = str_replace(basename($image_src[0]), basename($new_img_path), $image_src[0]);

                // resized output
                $vt_image = array(
                    'url' => $new_img,
                    'width' => $new_img_size[0],
                    'height' => $new_img_size[1],
                );

                return $vt_image;
            }

            // default output - without resizing
            $vt_image = array(
                'url' => $image_src[0],
                'width' => $image_src[1],
                'height' => $image_src[2],
            );

            return $vt_image;
        }

        return false;
    }
}
function jws_stringify_attributes($attributes)
{
    $atts = array();
    foreach ($attributes as $name => $value) {
        $atts[] = $name . '="' . esc_attr($value) . '"';
    }
    return implode(' ', $atts);
}

/* Title Bar */
if ( ! function_exists( 'jws_title_bar' ) ) {
	function jws_title_bar() {
		global $jws_option;
        global $wp_query;
        
       $current_term = $wp_query->get_queried_object();

		$delimiter = '/';
        if((is_single() && 'shows' == get_post_type())){
            if(isset($jws_option['shows-title-bar-type']) && $jws_option['shows-title-bar-type']) {
              $type = $jws_option['shows-title-bar-type'];
            } 
        }else {
           if(get_post_meta( get_the_ID(), 'titlebar-type', 1 ) && get_post_meta( get_the_ID(), 'titlebar-type', 1 ) != "global") {
                $type = get_post_meta( get_the_ID(), 'titlebar-type', 1 );
            }else {
                $type="";
            } 
        }
            $breadcrumb = 'yes';
           if(get_post_meta( get_the_ID(), 'titlebar-breadcrumbs', 1 ) && get_post_meta( get_the_ID(), 'titlebar-breadcrumbs', 1 ) != "global") {
                $breadcrumb = get_post_meta( get_the_ID(), 'titlebar-type', 1 );
            }elseif( isset($jws_option['blog-show-breadcrumbs'])&& (( $wp_query->is_main_query() && is_post_type_archive( 'shows' ) ) || ( is_tax() && ( isset( $current_term->taxonomy ) && $current_term->taxonomy =='shows_cat'   ) ))) {
                 $breadcrumb = 'no';
            }elseif((is_archive() || is_category() || is_tag()) && 'post' == get_post_type() && isset($jws_option['blog-show-breadcrumbs']) && empty($jws_option['blog-show-breadcrumbs']) ) {
                $breadcrumb = 'no';
            }elseif((is_single()) && 'post' == get_post_type() && isset($jws_option['single-blog-show-breadcrumbs']) && empty($jws_option['single-blog-show-breadcrumbs']) ) {
                $breadcrumb = 'no';
            }
            else {
                if(isset($jws_option['show-breadcrumbs']) && $jws_option['show-breadcrumbs']) {
                  $breadcrumb = 'yes';
                } 
            } 
        
       
        $style = "";
        if(get_post_meta( get_the_ID(), 'title_bar_image', 1 )) {
            $style .= 'background-image:url('.get_post_meta( get_the_ID(), 'title_bar_image', 1 ).');';
        }
        if(get_post_meta( get_the_ID(), 'title_bar_text_align', 1 )) {
            $style .= 'text-align:'.get_post_meta( get_the_ID(), 'title_bar_text_align', 1 ).';';
        }
       
       
            if(is_singular( 'post' ) && $type == "type1"){
                $subtitle = $jws_option['single_blog_sub_title'];
            }elseif(get_post_type() == 'show'  && $type == "type1"){
                $subtitle = $jws_option['shows_sub_title'];
            }else {
                 if( isset($jws_option['sub_title']) && $jws_option['sub_title'] && $type == "type1") {
                    $subtitle = $jws_option['sub_title'];
                } 
            }
              
       
        $subtitle_page = get_post_meta( get_the_ID(), 'sub_titlebar', 1 );
         if(isset($subtitle_page) && !empty($subtitle_page) ) {
            $subtitle = $subtitle_page;
         }
        if((isset($jws_option['title-bar-switch']) && $jws_option['title-bar-switch']) || !isset($jws_option['title-bar-switch']) ) :
            if((is_archive() || is_category() || is_tag()) && 'post' == get_post_type() && isset($jws_option['title-bar-switch']) && empty($jws_option['title-bar-switch']) ) {
                return false;
            }
		?>
			<div class="jws-title-bar-wrap <?php echo esc_attr($type)?>" style="<?php echo esc_attr($style); ?>">
				<div class="container">
							<div class="jws-title-bar">
							<h2 class="jws-text-ellipsis"><?php echo jws_page_title(); ?></h2>
                            <?php if(isset($subtitle) && !empty($subtitle) ) : ?>
                                  <span class="subtitle"><?php echo esc_html($subtitle);?></span>
                             <?php endif; ?>
                             <?php if($breadcrumb == 'yes'): ?>
    							<div class="jws-path">
    									<div class="jws-path-inner">
    										<?php echo jws_page_breadcrumb($delimiter); ?>
    									</div>
    							</div>
                            <?php endif; ?>
							</div>
				</div>
			</div>
		<?php 
        endif;
	}
}

/* Page breadcrumb */
if (!function_exists('jws_page_breadcrumb')) {
    function jws_page_breadcrumb($delimiter) {
		ob_start();

		$home = esc_html__('Home', 'netfx');
       
		global $post;
		$homeLink = home_url();
		if( is_home() ){
			_e('Home', 'netfx');
		}else{
			echo '<a href="' . $homeLink . '">' . $home . '</a> ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ';
		}
        
        if ( is_category() ) {
			$thisCat = get_category(get_query_var('cat'), false);
			if ($thisCat->parent != 0) echo get_category_parents($thisCat->parent, TRUE, ' ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ');
			echo '<span class="current">' . esc_html__('Archive by category: ', 'netfx') . single_cat_title('', false) . '</span>';

		} elseif ( is_search() ) {
			echo '<span class="current">' . esc_html__('Search results for: ', 'netfx') . get_search_query() . '</span>';

		} elseif ( is_post_type_archive( 'product' ) ) {
			echo '<span class="current">' . esc_html__('Shop', 'netfx') . '</span>';

		} elseif ( is_day() ) {
			echo '<a href="' . get_month_link(get_the_time('Y'),get_the_time('m')) . '">' . get_the_time('F').' '. get_the_time('Y') . '</a> ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ';
			echo '<span class="current">' . get_the_time('d') . '</span>';

		} elseif ( is_month() ) {
			echo '<span class="current">' . get_the_time('F'). ' '. get_the_time('Y') . '</span>';

		} 
        elseif ( is_month() ) {
			echo '<span class="current">' . get_the_time('F'). ' '. get_the_time('Y') . '</span>';

		}
        elseif ( is_single() && !is_attachment() ) {
			if ( get_post_type() != 'post' ) {
				if(get_post_type() == 'portfolio'){
					$terms = get_the_terms(get_the_ID(), 'portfolio_category', '' , '' );
					if($terms) {
						the_terms(get_the_ID(), 'portfolio_category', '' , ', ' );
						echo '' . '<span class="current">' . get_the_title() . '</span>';
					}else{
						echo '<span class="current">' .esc_html('Portfolio Details', 'netfx'). '</span>';
					}
				}elseif(get_post_type() == 'jwsdonations'){
					$terms = get_the_terms(get_the_ID(), 'recipe_category', '' , '' );
					if($terms) {
						the_terms(get_the_ID(), 'recipe_category', '' , ', ' );
						echo ' ' . '<span class="current">' .esc_html('Causes Details', 'netfx'). '</span>';
					}else{
						echo '<span class="current">' . get_the_title() . '</span>';
					}
				}elseif(get_post_type() == 'team'){
					$terms = get_the_terms(get_the_ID(), 'team_category', '' , '' );
					if($terms) {
						//the_terms(get_the_ID(), 'team_category', '' , ', ' );
						echo '' . '<span class="current">'.esc_html('Team Details', 'netfx'). '</span>';
					}else{
						echo '<span class="current">' . get_the_title() . '</span>';
					}
				}elseif(get_post_type() == 'testimonial'){
					$terms = get_the_terms(get_the_ID(), 'testimonial_category', '' , '' );
					if($terms) {
						the_terms(get_the_ID(), 'testimonial_category', '' , ', ' );
						echo '' . '<span class="current">' .esc_html('Testimonial Details', 'netfx').  '</span>';
					}else{
						echo '<span class="current">' . get_the_title() . '</span>';
					}
				}elseif(get_post_type() == 'story'){
						echo '<span class="current">' . get_the_title() . '</span>';
				}elseif(get_post_type() == 'product'){
					$terms = get_the_terms(get_the_ID(), 'product_cat', '' , '' );
					if($terms) {
					//	the_terms(get_the_ID(), 'product_cat', ' ' , ', ' , '<span class="delimiter">'.' ' . $delimiter . ' ' . '</span>'  );
                        
                	
                		if( $terms ) {
                			$term    = current( $terms );
                			$terms   = jws_get_term_parents( $term->term_id, 'product_cat' );
                			$terms[] = $term->term_id;
                
                			foreach ( $terms as $term_id ) {
                				$term    = get_term( $term_id, 'product_cat'  );

								echo '<a href="'.get_term_link( $term, 'product_cat'  ).'">'.$term->name.'<span class="delimiter">'.' ' . $delimiter . ' ' . '</span></a>';
                			}
                		}
						echo ''  . '<span class="current">' .get_the_title(). '</span>';
					}else{
						echo '<span class="current">'.the_title().'</span>';
					}
				}else{
					if(is_singular( 'event' )) {
						echo '<span class="current">'.esc_html('Event Details', 'netfx').'</span>';
						
					} else {
						$post_type = get_post_type_object(get_post_type());
						$slug = $post_type->rewrite;
						echo '<a href="' . $homeLink . '/' . $slug['slug'] . '/">' . $post_type->labels->singular_name . '</a>';
						echo ' ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ' . '<span class="current">' . get_the_title() . '</span>';
					}
				}

			} else {
				$cat = get_the_category(); $cat = $cat[0];
				$cats = get_category_parents($cat, TRUE, ' ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ');
   	  
				echo ' '.$cats;
                	echo ''  . '<span class="current">' .get_the_title(). '</span>';
			}

		} elseif ( !is_single() && !is_page() && get_post_type() != 'post' && !is_404() ) {
			$post_type = get_post_type_object(get_post_type());
			if($post_type) echo '<span class="current">' . $post_type->labels->singular_name . '</span>';
		} elseif ( is_attachment() ) {
			$parent = get_post($post->post_parent);
			echo '<a href="' . get_permalink($parent) . '">' . $parent->post_title . '</a>';
			echo ' ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ' . '<span class="current">' . get_the_title() . '</span>';
		} elseif ( is_page() && !$post->post_parent ) {
			echo '<span class="current">' . get_the_title() . '</span>';

		} elseif ( is_page() && $post->post_parent ) {
			$parent_id  = $post->post_parent;
			$breadcrumbs = array();
			while ($parent_id) {
				$page = get_page($parent_id);
				$breadcrumbs[] = '<a href="' . get_permalink($page->ID) . '">' . get_the_title($page->ID) . '</a>';
				$parent_id = $page->post_parent;
			}
			$breadcrumbs = array_reverse($breadcrumbs);
			for ($i = 0; $i < count($breadcrumbs); $i++) {
				echo wp_kses_post($breadcrumbs[$i]);
				if ($i != count($breadcrumbs) - 1)
					echo ' ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ';
			}
			echo ' ' . '<span class="delimiter">'. $delimiter . '</span>' . ' ' . '<span class="current">' . get_the_title() . '</span>';

		} elseif ( is_tag() ) {
			echo '<span class="current">' . esc_html__('Posts tagged: ', 'netfx') . single_tag_title('', false) . '</span>';
		} elseif ( is_author() ) {
			global $author;
			$userdata = get_userdata($author);
			echo '<span class="current">' . esc_html__('Articles posted by ', 'netfx') . $userdata->display_name . '</span>';
		} elseif ( is_404() ) {
			echo '<span class="current">' . esc_html__('Page not found', 'netfx') . '</span>';
		}

		if ( get_query_var('paged') ) {
			if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ' (';
				echo ' '.'<span class="delimiter">'.$delimiter.'</span> ' . ' '.'<span class="paged-number">'.esc_html__('Page', 'netfx') . ' ' . get_query_var('paged').'</span>';
			if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ')';
		}
			
		return ob_get_clean();
    }
}
/* Page title */
if (!function_exists('jws_page_title')) {   
    function jws_page_title() { 
            ob_start();
            global $jws_option;
             global $wp_query;
       $current_term = $wp_query->get_queried_object();
			if( is_home() ){
				_e('Home', 'netfx');
   	        }elseif(is_404()){
                esc_html_e('Page not found', 'netfx');   
			}elseif(is_search()){
                esc_html_e('Search Keyword: ', 'netfx'). '<span class="keywork">'. get_search_query( false ). '</span>';
            }elseif(is_post_type_archive( 'product' )){
				woocommerce_page_title();
            }else {
                if($wp_query->is_main_query() && is_post_type_archive( 'shows' ) ) {
                    esc_html_e('shows', 'netfx');
        		}elseif (is_category() || (is_tax() && ( isset( $current_term->taxonomy ) && $current_term->taxonomy =='shows_cat'))){
                    single_cat_title();
                }elseif(get_post_type() == 'event' || get_post_type() == 'jwsdonations'  || get_post_type() == 'testimonial' ){
                    single_term_title();
                }
                elseif (is_tag()){
                    single_tag_title();
                }elseif (is_author()){
                    printf(__('Author: %s', 'netfx'), '<span class="vcard">' . get_the_author() . '</span>');
                }elseif (is_day()){
                    printf(__('Day: %s', 'netfx'), '<span>' . get_the_date() . '</span>');
                }elseif (is_month()){
                    printf(__('Month: %s', 'netfx'), '<span>' . get_the_date() . '</span>');
                }elseif (is_year()){
                    printf(__('Year: %s', 'netfx'), '<span>' . get_the_date() . '</span>');
                }elseif (is_tax('post_format', 'post-format-aside')){
                    esc_html_e('Asides', 'netfx');
                }elseif (is_tax('post_format', 'post-format-gallery')){
                    esc_html_e('Galleries', 'netfx');
                }elseif (is_tax('post_format', 'post-format-image')){
                    esc_html_e('Images', 'netfx');
                }elseif (is_tax('post_format', 'post-format-video')){
                    esc_html_e('Videos', 'netfx');
                }elseif (is_tax('post_format', 'post-format-quote')){
                    esc_html_e('Quotes', 'netfx');
                }elseif (is_tax('post_format', 'post-format-link')){
                    esc_html_e('Links', 'netfx');
                }elseif (is_tax('post_format', 'post-format-status')){
                    esc_html_e('Statuses', 'netfx');
                }elseif (is_tax('post_format', 'post-format-audio')){
                    esc_html_e('Audios', 'netfx');
                }elseif (is_tax('post_format', 'post-format-chat')){
                    esc_html_e('Chats', 'netfx');
                }
                elseif (is_singular( 'post' ) && !empty($jws_option['single_blog_custom_title'])){
                    esc_html_e($jws_option['single_blog_custom_title'], 'netfx');
                }
                elseif(get_post_type() == 'product' && !is_single()){
                   single_term_title();
                }else{
                    the_title();
                }
            }
                
            return ob_get_clean();
    }
}
/**
 * Searches for term parents' IDs of hierarchical taxonomies, including current term.
 * This function is similar to the WordPress function get_category_parents() but handles any type of taxonomy.
 * Modified from Hybrid Framework
 *
 * @param int|string    $term_id  The term ID
 * @param object|string $taxonomy The taxonomy of the term whose parents we want.
 *
 * @return array Array of parent terms' IDs.
 */
function jws_get_term_parents( $term_id = '', $taxonomy = 'category' ) {
	// Set up some default arrays.
	$list = array();

	// If no term ID or taxonomy is given, return an empty array.
	if ( empty( $term_id ) || empty( $taxonomy ) ) {
		return $list;
	}

	do {
		$list[] = $term_id;

		// Get next parent term
		$term    = get_term( $term_id, $taxonomy );
		$term_id = $term->parent;
	} while ( $term_id );

	// Reverse the array to put them in the proper order for the trail.
	$list = array_reverse( $list );
	array_pop( $list );

	return $list;
}

if (!function_exists('jws_query_pagination')) {
    function jws_query_pagination($wp_query)
    {
        	$big = 999999999;
        	$pagi = '<div class="jws-pagination-number">';
        	$pagi .= paginate_links( array(
        		'prev_text'          => '<i class="eva-arrow-ios-back-outline" aria-hidden="true"></i>',
        		'next_text'          => '<i class="eva-arrow-ios-forward-outline" aria-hidden="true"></i>',
        		'base' => str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
        		'format' => '?paged=%#%',
        		'current' => max( 1, get_query_var('paged') ),
        		'total' => $wp_query->max_num_pages,
                'type' => 'list'
        	) );
        	$pagi .= '</div>';
            return $pagi;
    }
}

function jws_mime_types($mimes)
{
    $mimes['svg'] = 'image/svg+xml';
    return $mimes;
}

add_filter('upload_mimes', 'jws_mime_types');

/*Custom comment list*/
function jws_custom_comment($comment, $args, $depth)
{
    $GLOBALS['comment'] = $comment;
    extract($args, EXTR_SKIP);

    if ('div' == $args['style']) {
        $tag = 'div ';
        $add_below = 'comment';
    } else {
        $tag = 'li ';
        $add_below = 'div-comment';
    }
    ?>
    <<?php echo wp_kses_post($tag) ?><?php comment_class(empty($args['has_children']) ? '' : 'parent') ?> id="comment-<?php comment_ID() ?>">
    <?php if ('div' != $args['style']) : ?>
    <div id="div-comment-<?php comment_ID() ?>" class="comment-body">
    <?php endif; ?>
    
        <div class="comment-avatar">
            <?php if ($args['avatar_size'] != 0) echo get_avatar($comment, $args['avatar_size']); ?>
        </div>
        <div class="comment-info">
            <div class="comment-header-info">
                <span class="comment-author"><?php printf(esc_html__('%s', 'netfx'), get_comment_author()); ?></span>
                
                
            </div>
            <?php comment_text(); ?>
            <span class="reply">
                    <?php comment_reply_link(array_merge($args, array('add_below' => $add_below, 'depth' => $depth, 'max_depth' => $args['max_depth']))); ?>
                </span>
            <span class="comment-date"><?php printf(esc_html__('%1$s ', 'netfx'), get_comment_date()); ?></span>
            <?php if ($comment->comment_approved == '0') : ?>
                <em class="comment-awaiting-moderation"><?php esc_html_e('Your comment is awaiting moderation.', 'netfx'); ?></em>
                <br/>
            <?php endif; ?>
        </div>
    
        <?php if ('div' != $args['style']) : ?>
        </div>
    <?php endif; ?>
    <?php
}


add_filter( 'gettext', 'theme_change_comment_cookie_label', 20, 3 );
function theme_change_comment_cookie_label( $translated_text, $text, $domain ) {
    if ( is_singular() ) {
        switch ( $translated_text ) {
            case 'Save my name, email, and website in this browser for the next time I comment.' :
                $translated_text = esc_html__( 'Save my name, email in this browser for the next time I comment.', 'netfx' );
                break;
        }
    }
    return $translated_text;
}
/**
 * Render post tags.
 *
 * @since 1.0.0
 */
if (!function_exists('jws_get_tags')){
    function jws_get_tags()
    {
        


        // Get the tag list
        $tags_list = get_the_tag_list();
        $output = '';
        if ($tags_list) {
            $output .= sprintf('<div class="post-tags">%2$s' . esc_html__('%1$s', 'netfx') . '</div>', $tags_list, '<span>' . esc_html__('Tags:', 'netfx') . '</span>');
        }
        return apply_filters('jws_get_tags', $output);
    }
}
    


/**
 * ------------------------------------------------------------------------------------------------
 * Single product share buttons
 * ------------------------------------------------------------------------------------------------
 */

if (!function_exists('jws_share_buttons')) {
    function jws_share_buttons($text=null, $show_text=null)
    {
        global $jws_option;
        if($show_text != 'show') {
            $text = isset($jws_option['text_share']) ? $jws_option['text_share'] : esc_html__('Share:','netfx');
        }
        ?>

        <div class="jws-share">
           
                <button><span>
                <?php  if(isset($jws_option['text_share'])) {
                        echo esc_html($jws_option['text_share']);
                    }else {
                        echo esc_html__('Share:','netfx');
                    } ?>
                </span>
                   <i aria-hidden="true" class="eva eva-share-outline"></i>
                     <i aria-hidden="true" class="lnr lnr-cross"></i>
                </button>
      
            <div class="addthis_inline_share_toolbox" data-url="<?php the_permalink(); ?>" data-title="<?php the_title_attribute(); ?>">
                <div class="post-share-inner">
      
                    <a class="addthis_button_facebook"><span class="fab fa-facebook-f"></span></a>
            
            		<a class="addthis_button_twitter"><span class="fab fa-twitter"></span></a>
            
            		<a class="addthis_button_linkedin"><span class="fab fa-linkedin-in"></span></a>
            
            		<a class="addthis_button_more"><span class="fas fa-plus"></span></a>
                </div>
           </div>     
       </div>

        <?php
    }
}

if (!function_exists('jws_post_nav')) : /**
     * Display navigation to next/previous post when applicable.
     */
        {
            function jws_post_nav()
            {
                

                ?>
                <nav class="navigation post-navigation" role="navigation">
                    <div class="nav-links">
                        <?php
                        if (is_attachment()) :
                            previous_post_link('%link',
                                __('%title', 'netfx'));
                        else :
                            previous_post_link('<span class="left"> %link </span>', 'PREV' , 'netfx');    
                            next_post_link('<span class="right"> %link </span>', 'NEXT', 'netfx');
                        endif;
                        ?>
                    </div>
                    <!-- .nav-links -->
                </nav><!-- .navigation -->
                <?php
            }
        }
endif;

/*Author*/
if ( ! function_exists( 'jws_author_render' ) ) {
	function jws_author_render() {
    	$bio = get_the_author_meta('description');
        if(empty($bio)) return;
		ob_start();
         
		?>
		
		<div class="blog-about-author">
        <h4 class="title-author"><?php esc_html_e('Author' , 'netfx') ?></h4>
			<div class="blog-author-avatar"><?php echo get_avatar( get_the_author_meta( 'ID' ), 170 ); ?></div>
			<div class="blog-author-info">
                <h3 class="at-name"><?php the_author(); ?></h3>
                <h6 class="at-name"><?php echo get_the_author_meta('job'); ?></h6>
				<div class="description"><?php echo wp_kses_post($bio); ?></div>
                <div class="icon-author">
                    <a href="<?php echo get_the_author_meta('facebook'); ?>"><i class="fa fa-facebook"></i></a>
                    <a href="<?php echo get_the_author_meta('twitter'); ?>"><i class="fa fa-twitter"></i></a>
                    <a href="<?php echo get_the_author_meta('linkedin'); ?>"><i class="fa fa-google-plus"></i></a>
                </div>
			</div>
		</div>
		<?php
		return  ob_get_clean();
	} 
}

/* Add Field To Admin User */
function jws_custom_field_user($profile_fields) {
    	// Add new fields
        $profile_fields['job'] = 'Job';
    	$profile_fields['twitter'] = 'Twitter URL';
    	$profile_fields['facebook'] = 'Facebook URL';
    	$profile_fields['linkedin'] = 'Linkedin';
    	return $profile_fields;
}
add_filter('user_contactmethods', 'jws_custom_field_user');


function jws_include_svg( $attachment_id ) {

	if( ! $attachment_id || ! is_numeric( $attachment_id ) ) {
		return '';
	}

	$url = get_attached_file( $attachment_id );

	return $url ? $url : false;
}





/**
 * ------------------------------------------------------------------------------------------------
 * Get post image
 * ------------------------------------------------------------------------------------------------
 */

if (!function_exists('jws_get_post_thumbnail')) {
    function jws_get_post_thumbnail($size = 'full', $attach_id = false)
    {
        global $post, $netfx_loop;
        if (has_post_thumbnail()) {

            if (function_exists('jws_getImageBySize')) {
                if (!$attach_id) $attach_id = get_post_thumbnail_id();

                $img = jws_getImageBySize(array('attach_id' => $attach_id, 'thumb_size' => $size, 'class' => 'attachment-large wp-post-image'));
                $img = $img['thumbnail'];

            } else {
                $img = get_the_post_thumbnail($post->ID, $size);
                
            }

            return $img;
        }
    }
}

function jws_gt_get_post_view() {
   
    $count = get_post_meta( get_the_ID(), 'post_views_count', true );
    if(!empty($count)) {
        return "$count";
    }else {
        return "0";
    }
    
}
function jws_gt_set_post_view() {
    $key = 'post_views_count';
    $post_id = get_the_ID();
    $count = (int) get_post_meta( $post_id, $key, true );
    $count++;
    update_post_meta( $post_id, $key, $count );
}
function jws_gt_set_post_time() {
    $content = get_post_field( 'post_content', get_the_ID() );
    $word_count = str_word_count( strip_tags( $content ) );
    $readingtime = ceil($word_count / 200);

    if ($readingtime == 1) {
      $timer = esc_html__(' min read','netfx');
    } else {
      $timer = esc_html__(' mins read','netfx');
    }
    $totalreadingtime = $readingtime . $timer;
    $key = 'time_read';
    $post_id = get_the_ID();
    update_post_meta( $post_id, $key, $totalreadingtime );
}
function gt_posts_column_views( $columns ) {
    $columns['post_views'] = 'Views';
    return $columns;
}
function gt_posts_custom_column_views( $column ) {
    if ( $column === 'post_views') {
        echo jws_gt_get_post_view();
    }
}
add_filter( 'manage_posts_columns', 'gt_posts_column_views' );
add_action( 'manage_posts_custom_column', 'gt_posts_custom_column_views' );


if ( ! function_exists( 'jws_related_post' ) ) {

	function jws_related_post() {
		global $post;
        global $jws_option;

        // Get page options
        $options = get_post_meta( get_the_ID(), '_custom_post_options', true );
        
        // Get product single style
     //   $style = ( is_array( $options ) && $options['post-single-style'] ) ? $options['post-single-style'] : ( cs_get_option( 'post-single-style' ) ? cs_get_option( 'post-single-style' ) : '1' );
		// Get post's tags
		$categories = wp_get_post_categories( $post->ID );

		if ( $categories ) {
			// Get id for all tags
			$category_ids = array();
			foreach ( $categories as $category ) {
				$category_ids[] = $category;
			}
			// Build arguments to query for related posts
			$args = array(
				'category__in'             => $category_ids,
				'post__not_in'        => array( $post->ID ),
				'posts_per_page'      => 2,
				'ignore_sticky_posts' => 1,
				'orderby'             => 'rand',
			);

			// Get related post
			$related = new wp_query( $args );
             $layout = 'layout3';
              $class_row = 'row blog-content';  
      $class_row .= ' jws-blog-'.$layout.'';
      $class_column = 'jws-blog-item col-xl-6 col-lg-6 col-12';
     
  
			?>
        <div class="section-blog post-related jws-blog-element">
            <div class="title-related">
                <h3><?php esc_html_e( 'Related posts', 'netfx' )  ?></h3>
            </div>
               <div class="<?php echo esc_attr($class_row); ?>">
                	<?php if ( have_posts() ) :
            			while ( $related->have_posts() ):
                        $related->the_post();
                        $num_comments = get_comments_number();
                            $format = has_post_format() ? get_post_format() : 'no_format';  
            				/*
            				 * Include the Post-Format-specific template for the content.
            				 * If you want to override this in a child theme, then include a file
            				 * called content-___.php (where ___ is the Post Format name) and that will be used instead.
            				 */
                             echo '<article class="'.$class_column.' '.$format.'">';
                            get_template_part( 'template-parts/content/blogs/archive-layout/'.$layout.'' );
                             ?>
                             
                              
                            </article>
            
            				
            			<?php
                        // End the loop.
                          endwhile;
            
            
            			// If no content, include the "No posts found" template.
            		else :
            			get_template_part( 'template-parts/content/content', 'none' );
            
            		endif;
            		?>
                    </div> 
            </div>

<?php
			// Reset global query object
			wp_reset_postdata();
		}
	}
}

/**
 * Add extra initialisation for Contact 7 Form in Elementor popups.
 **/
add_action( 'wp_footer', 'jws_back_top_top'); 
function jws_back_top_top() {
    global $jws_option;
    $layout = (isset($jws_option['to-top-layout'])) ? $jws_option['to-top-layout'] : 'with-shadow';
    $class = 'backToTop ';
    $class .= $layout;
    ?>
        <a href="#" class="<?php echo esc_attr($class); ?>"><span class="btn-icon btn-icon-custom">  </span></a>
    <?php
}


function getPostViews($postID){
     $count_key = 'post_views_count';
     $count = get_post_meta($postID, $count_key, true);
     if ($count == '') {
         delete_post_meta($postID, $count_key);
         add_post_meta($postID, $count_key, '0');

         return "0";
     }
     return $count;
}

function setPostViews($postID) {
    $count_key = 'post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if ($count== '' ) {
        $count = 0;
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
    } else {
        $count++;
        update_post_meta($postID, $count_key, $count);
    }
}


if(!function_exists('jws_send_mail_content')) {

    function jws_send_mail_content($jws_option) {
           
    $account_url = (isset($jws_option['login_form_redirect']) && !empty($jws_option['login_form_redirect'])) ? $jws_option['login_form_redirect'] : '';
                    
    if(isset($_GET['p'])){                                                  // If accessed via an authentification link
           $loc = function_exists('ct_65') ? ct_65($_GET['p']) : '';
             $data = unserialize($loc);
    
            
            $code = get_user_meta($data['id'], 'activationcode', true);
            $isActivated = get_user_meta($data['id'], 'is_activated', true);    // checks if the account has already been activated. We're doing this to prevent someone from logging in with an outdated confirmation link
            if( $isActivated ) {                                                // generates an error message if the account was already active
                echo '<div>'.esc_html__( 'Your account has been activated! You have been logged in and can now use the site to its full extent.' , 'netfx' ).'</div>';
                echo '<a href="'.get_home_url().'" class="btn-button btn-dark">'.esc_html__('Go To Home','netfx').'</a>';
                echo '<a href="'.$account_url.'" class="btn-button btn-solid">'.esc_html__('Go To My Account','netfx').'</a>';
            }
        
            else {
                if($code == $data['code']){                                     // checks whether the decoded code given is the same as the one in the data base
                    update_user_meta($data['id'], 'is_activated', 1);           // updates the database upon successful activation
                    $user_id = $data['id'];                                     // logs the user in
                    $user = get_user_by( 'id', $user_id ); 
                    if( $user ) {
                        wp_set_current_user( $user_id, $user->user_login );
                        wp_set_auth_cookie( $user_id );
                        do_action( 'wp_login', $user->user_login, $user );
                    }
                    echo '<div>'.esc_html__( 'Your account has been activated! You have been logged in and can now use the site to its full extent.' , 'netfx' ).'</div>';
                    echo '<a href="'.get_home_url().'">'.esc_html__('Go To Home','netfx').'</a>';
                    echo '<a href="'.$account_url.'">'.esc_html__('Go To My Account','netfx').'</a>';
                } else {
                    echo '<strong>'.esc_html__('Error:','netfx').'</strong> '.esc_html__('Account activation failed. Please try again in a few minutes or','netfx').' <a href="http://netfx.jwsuperthemes.com/verify-mail?u='.esc_attr($data['id']).'">'.esc_html__('resend the activation email','netfx').'</a>.<br />'.esc_html__('Please note that any activation links previously sent lose their validity as soon as a new activation email gets sent.<br />If the verification fails repeatedly, please contact our administrator.','netfx').'';
                }
            }
        }
        if(isset($_GET['u'])){                                          // If resending confirmation mail
            my_user_register($_GET['u']);
             echo esc_html__( 'Your activation email has been resent. Please check your email and your spam folder.','netfx');
        }
        if(isset($_GET['n'])){                                          // If account has been freshly created
             echo esc_html__( 'Thank you for creating your account. You will need to confirm your email address in order to activate your account. An email containing the activation link has been sent to your email address. If the email does not arrive within a few minutes, check your spam folder.','netfx' );
        }
    
    }
}