<?php
/**
 * The template for displaying all single posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */

get_header();
global $jws_option;
$sidebar = isset($jws_option['position_sidebar_service_single']) ? $jws_option['position_sidebar_service_single'] : 'full';
if($sidebar == 'full'){
   $content_col = 'col-xl-12 col-12'; 
   $sidebar_col = 'post_sidebar main-sidebar';
   $class = ' no_sidebar';
}else {
   $content_col = 'post_content col-xl-9 col-lg-12 col-12 order-xl-12 order-lg-1 order-1';
   $sidebar_col = 'post_sidebar main-sidebar col-xl-3 col-lg-12 col-12 order-xl-12 order-lg-12 order-12'; 
   $class = ' has_sidebar'; 
}



        if(isset($jws_option['services-title-bar-switch']) && $jws_option['services-title-bar-switch']) {
          if (isset($jws_option['select-titlebar-services']) && !empty($jws_option['select-titlebar-services'])) { ?>
             <div class="jws-title-bar">
        
               <?php  echo do_shortcode('[hf_template id="' . $jws_option['select-titlebar-services'] . '"]'); ?>
            </div>
        <?php }else {
             jws_title_bar();  
        }
        } 
?>

	<section id="primary" class="content-area">
		<main id="main" class="site-main">
            <div class="container">
                <div class="row">
                    <?php if($sidebar == 'left') : ?>
                        <div class="<?php echo esc_attr($sidebar_col); ?>">
                            <?php
                                if (isset($jws_option['select-sidebar-service-single']) && !empty($jws_option['select-sidebar-service-single'])) { 
                                             echo do_shortcode('[hf_template id="' . $jws_option['select-sidebar-service-single'] . '"]'); 
                                }else {
                                   if ( is_active_sidebar( 'sidebar-post' ) ) {
                        			     dynamic_sidebar( 'sidebar-post' );
                        		   } 
                                }	
    		                 ?>
                        </div>
                    <?php endif; ?> 
                    <div class="<?php echo esc_attr($content_col); ?>">
                    	<?php
                
                			/* Start the Loop */
                			while ( have_posts() ) :
                				the_post();
                				get_template_part( 'template-parts/content/services/single');
                				if ( is_singular( 'attachment' ) ) {
                					// Parent post navigation.
                					the_post_navigation(
                						array(
                							/* translators: %s: parent post link */
                							'prev_text' => sprintf( esc_html__( '<span class="meta-nav">Published in</span><span class="post-title">%s</span>', 'netfx' ), '%title' ),
                						)
                					);
                				} elseif ( is_singular( 'post' ) ) {
                					// Previous/next post navigation.
                					the_post_navigation(
                						array(
                							'next_text' => '<span class="meta-nav" aria-hidden="true">' . esc_html__( 'Next Post', 'netfx' ) . '</span> ' .
                								'<span class="screen-reader-text">' . esc_html__( 'Next post:', 'netfx' ) . '</span> <br/>' .
                								'<span class="post-title">%title</span>',
                							'prev_text' => '<span class="meta-nav" aria-hidden="true">' . esc_html__( 'Previous Post', 'netfx' ) . '</span> ' .
                								'<span class="screen-reader-text">' . esc_html__( 'Previous post:', 'netfx' ) . '</span> <br/>' .
                								'<span class="post-title">%title</span>',
                						)
                					);
                				}
                
                				// If comments are open or we have at least one comment, load up the comment template.
                				if ( comments_open() || get_comments_number() ) {
                					comments_template();
                				}
                
                			endwhile; // End of the loop.
                			?>
                    </div> 
                    <?php if($sidebar == 'right') : ?>
                        <div class="<?php echo esc_attr($sidebar_col); ?>">
                            <?php
                                if (isset($jws_option['select-sidebar-service-single']) && !empty($jws_option['select-sidebar-service-single'])) { 
                                             echo do_shortcode('[hf_template id="' . $jws_option['select-sidebar-service-single'] . '"]'); 
                                }else {
                                   if ( is_active_sidebar( 'sidebar-post' ) ) {
                        			     dynamic_sidebar( 'sidebar-post' );
                        		   } 
                                }	
    		                 ?>
                        </div>
                    <?php endif; ?> 
                </div>
            </div>
		</main><!-- #main -->
	</section><!-- #primary -->

<?php
get_footer();
