<?php
/**
 * The template for displaying all single posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */

get_header();

wp_enqueue_script('addthis-widget');
global $jws_option; 
$layout = (isset($jws_option['blog_single_layout'])) ? $jws_option['blog_single_layout'] : 'layout1';
$position_sidebar = 'right';
if (isset($_GET['sidebar']) && $_GET['sidebar']) {
    $position_sidebar = $_GET['sidebar'];
}else {
    if(isset($jws_option['position_sidebar_blog_single'])) {
        $position_sidebar = $jws_option['position_sidebar_blog_single'];
    }
}
if(($position_sidebar == 'full') || ((did_action( 'elementor/loaded' )) && \Elementor\Plugin::$instance->editor->is_edit_mode())) {
   $content_col = 'col-xl-12 col-12'; 
   $sidebar_col = 'postt_sidebar main-sidebar';
   $class = ' no_sidebar';
}else {
   if(!is_active_sidebar( 'blog-sidebar' )){
       $content_col = ' col-xl-12 col-12'; 
       $sidebar_col = 'postt_sidebar main-sidebar';
       $class = ' no_sidebar'; 
   }else{
       $content_col = ($layout == 'layout2' || $layout == 'layout7' || $layout == 'layout8') ? 'post_content col-xl-9 col-lg-12 col-12' : 'post_content col-xl-8 col-lg-12 col-12';
       $sidebar_col = ($layout == 'layout2' || $layout == 'layout7' || $layout == 'layout8') ? 'post_sidebar main-sidebar col-xl-3 col-lg-12 col-12' : 'post_sidebar main-sidebar col-xl-4 col-lg-12 col-12'; 
       $class = ' has_sidebar'; 
   } 
}

$format = get_post_format();
if((isset($jws_option['blog-title-bar-switch']) && $jws_option['blog-title-bar-switch']) || !isset($jws_option['blog-title-bar-switch'] )) {
          jws_title_bar();  
        } 
?>
	<div id="primary" class="content-area<?php echo esc_attr(' single_blog_'.$layout); ?>">
		<main id="main" class="site-main">
            <div class="<?php if(($layout != 'layout3') || $layout != 'layout4') echo esc_attr('container ');?>single-blog<?php echo esc_attr($class); ?>">
                <div class="row">
                
                    <?php if($position_sidebar == 'left') : ?>
                        <div class="<?php echo esc_attr($sidebar_col); ?>">
                           <div class="jws_blog_sidebar">
                        <?php
                                if (isset($jws_option['select-sidebar-post-single']) && !empty($jws_option['select-sidebar-post-single'])) { 
                                             echo do_shortcode('[hf_template id="' . $jws_option['select-sidebar-post-single'] . '"]'); 
                                }else {
                                   if ( is_active_sidebar( 'blog-sidebar' ) ) {
                        			     dynamic_sidebar( 'blog-sidebar' );
                        		   } 
                                }	
    		                 ?>
                        </div>
                        </div>
                    <?php endif; ?>    
                    <div class="<?php echo esc_attr($content_col); ?>">
                        <?php
                			/* Start the Loop */
                			while ( have_posts() ) :
                				the_post();
                                jws_gt_set_post_view();
                                jws_gt_set_post_time();
                                 
                				get_template_part( 'template-parts/content/blogs/single/entry_'.$layout.'' );
                             the_posts_navigation();
                            
                			endwhile; // End of the loop.
                             wp_reset_postdata();
            			?>
                           <footer>
                                <?php 
                                
                                    echo '<div class="tag-share">';
                                    echo jws_get_tags();?>
                                     <?php if(function_exists('jws_share_buttons')):?>
                                     <div class="jws-share-bottom">
                                            <div class="addthis_inline_share_toolbox" data-url="<?php the_permalink(); ?>" data-title="<?php the_title_attribute(); ?>">
                                                <div class="post-share-inner">
                                      
                                                     <a class="addthis_button_facebook"><span class="fab fa-facebook-f"></span></a>
            
                                            		<a class="addthis_button_twitter"><span class="fab fa-twitter"></span></a>
                                            
                                            		<a class="addthis_button_linkedin"><span class="fab fa-linkedin-in"></span></a>
            
                                                </div>
                                           </div>     
                                       </div>
                                     <?php endif;?>
                                    <?php echo '</div>';
                                     get_template_part( 'template-parts/content/blogs/single/template/author_box/author_box1' ); 
                                    get_template_part( 'template-parts/content/blogs/single/template/nav/nav1' );
                                   
                                   
                                 ?>
                                  <?php 
                                    if((isset($jws_option['select-related-blog']) && !empty($jws_option['select-related-blog'])) && ($layout != 'layout3' && $layout != 'layout5' && $layout != 'layout6' && $layout != 'layout7' && $layout != 'layout8')) { 
                                         $related = get_posts( array( 'category__in' => wp_get_post_categories($post->ID), 'numberposts' => 100,'post_type' => 'post', 'post__not_in' => array($post->ID) ) );
                                         if(isset($related[0])) : ?>
                                         <div class="post_related">
                                            <?php echo do_shortcode('[hf_template id="' . $jws_option['select-related-blog'] . '"]'); ?>
                                         </div>
                                <?php endif; }else {
                                    echo jws_related_post();
                                }  ?>                                 
                                <?php
                                     // If comments are open or we have at least one comment, load up the comment template.
                    				if ( comments_open() || get_comments_number() ) {
                    					comments_template();
                    				}
                                 ?>
                            </footer>                         
                    </div>
                    <?php if($position_sidebar == 'right') : ?>
                        <div class="<?php echo esc_attr($sidebar_col); ?>">
                        <div class="jws_blog_sidebar">
                        <?php
                                if (isset($jws_option['select-sidebar-post-single']) && !empty($jws_option['select-sidebar-post-single'])) { 
                                             echo do_shortcode('[hf_template id="' . $jws_option['select-sidebar-post-single'] . '"]'); 
                                }else {
                                   if ( is_active_sidebar( 'blog-sidebar' ) ) {
                        			     dynamic_sidebar( 'blog-sidebar' );
                        		   } 
                                }	
    		                 ?>
                        </div>
                            
                        </div>
                    <?php endif; ?> 
                </div>
               
            </div>
		</main><!-- #main -->
	</div><!-- #primary -->
<?php
get_footer();

