<?php
/**
 * Template part for displaying posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */
global $jws_option; 

 $format = has_post_format() ? get_post_format() : 'no_format';  
 $comments_number = get_comments_number();
    if($comments_number > 1 || $comments_number = 0) {
        $text_comment = esc_html(' Comments','netfx');
    }else {
        $text_comment = esc_html(' Comment','netfx');
    }
    $month = get_the_time('M');
    $year = get_the_time('Y');
?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
<?php if($format != 'no_format' && $format !='link' && $format !='quote') {
                
                echo '<div class="post-format-wrap">';
                    get_template_part( 'template-parts/content/blogs/single/format/'.$format.'' );
                echo '</div>';    
             }else { ?>
             <?php if (has_post_thumbnail()): ?>
               <div class="post_thumbnail">
                    <?php 
                           if (isset($_GET['img_size']) && $_GET['img_size']) {
                                echo jws_get_post_thumbnail($_GET['img_size']);
                           }elseif(isset($jws_option['single_blog_imagesize']) && !empty($jws_option['single_blog_imagesize'])) {
                                 echo jws_get_post_thumbnail($jws_option['single_blog_imagesize']);
                            }else {
                                echo jws_get_post_thumbnail('full');
                            } 
                       
                    ?>
   
                </div>
                 <?php endif; ?>
            <?php } ?>
    <?php if($format !='link' && $format !='quote') { ?>
            <header>
                 <span class="post_cat"><?php echo get_the_term_list(get_the_ID(), 'category', '', ''); ?></span> 
                  <div class="jws-post-meta">
                    <span class="entry-date">
                        <a  href="<?php echo get_month_link($year, $month); ?>">
                         <?php echo get_the_date(); ?>
                        </a>
                    </span>
                     <code>/</code>
                     <span class="jws-post-author">
                     <?php echo esc_html__('By ','netfx'); ?>
                        <a  href="<?php echo esc_url(get_author_posts_url( get_the_author_meta('ID') )); ?>"><?php echo '<span>'.get_the_author().'</span>'; ?></a> 
                    </span>                      
                </div>
                <h1 class="entry_title">
                    <?php echo get_the_title(); ?>
                </h1>
                 <div class="jws_post_more_info">
                        <?php if(get_post_meta(get_the_ID(), 'blog_time', true)): ?>
                            <div class="time-read"><i aria-hidden="true" class="eva eva-clock-outline"></i><span><?php echo esc_html(get_post_meta(get_the_ID(), 'blog_time', true)) ?> </span></div>
                        <?php endif;?>
                            <a href="#comments" class="comment-number"><i aria-hidden="true" class="eva eva-message-circle-outline"></i><span><?php echo esc_html(get_comments_number()) ?>&nbsp;<?php echo _n( 'comment', 'comments', get_comments_number(), 'netfx' ); ?></span></a>
                        <?php if(function_exists('jws_share_buttons')) echo jws_share_buttons('SHARE'); ?>
               </div>
              
              
           </header>
            
           <?php }elseif ($format =='link'){ ?>
                <header>
                    <div class="link-post">
                    <img src="<?php echo get_template_directory_uri().'/assets/images/link.svg'; ?>">
                    </div>
                    <span class="entry-date">
                             <?php echo get_the_date(); ?>
                        </span>
                    <h1 class="entry_title">
                        <a href="<?php echo esc_url(get_post_meta(get_the_ID(), 'blog_url_link', true)) ?>"><?php the_title(); ?></a>
                    </h1>
                        
                     <div class="jws_post_more_info">
                            <?php if(get_post_meta(get_the_ID(), 'blog_time', true)): ?>
                                <div class="time-read"><i aria-hidden="true" class="eva eva-clock-outline"></i><span><?php echo esc_html(get_post_meta(get_the_ID(), 'blog_time', true)) ?> </span></div>
                            <?php endif;?>
                                <div class="comment-number"><i aria-hidden="true" class="eva eva-message-circle-outline"></i><span><?php echo esc_html(get_comments_number()) ?>&nbsp;<?php echo _n( 'comment', 'comments', get_comments_number(), 'netfx' ); ?></span></div>
                            <?php if(function_exists('jws_share_buttons')) echo jws_share_buttons('SHARE'); ?>
                   </div>
               </header>
           <?php }elseif ($format =='quote'){ ?>
                <header>
                    <span class="quote-icon">
                       <img src="<?php echo get_template_directory_uri().'/assets/images/quote.svg'; ?>">
                    </span>
                    <span class="entry-date">
                             <?php echo get_the_date(); ?>
                        </span>
                    <h1 class="entry_title">
                        <?php the_title(); ?>
                    </h1>
                <span class="jws-post-author"><?php echo get_the_author(); ?></span>
                 <div class="jws_post_more_info">
                        <?php if(get_post_meta(get_the_ID(), 'blog_time', true)): ?>
                            <div class="time-read"><i aria-hidden="true" class="eva eva-clock-outline"></i><span><?php echo esc_html(get_post_meta(get_the_ID(), 'blog_time', true)) ?> </span></div>
                        <?php endif;?>
                            <div class="comment-number"><i aria-hidden="true" class="eva eva-message-circle-outline"></i><span><?php echo esc_html(get_comments_number()) ?>&nbsp;<?php echo _n( 'comment', 'comments', get_comments_number(), 'netfx' ); ?></span></div>
                        <?php if(function_exists('jws_share_buttons')) echo jws_share_buttons('SHARE'); ?>
               </div>
               </header>
           <?php } ?>
           <div class="entry_content">
                <?php the_content(); ?> 
           </div>
          
		<?php
		wp_link_pages(
			array(
				'before' => '<div class="page-links">' . esc_html__( 'Pages:', 'netfx' ),
				'after'  => '</div>',
			)
		);
		?>

</article><!-- #post-<?php the_ID(); ?> -->