<?php
/**
 * Template part for displaying posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */
global $jws_option; 
$comments_number = get_comments_number();
$archive_year  = get_the_time('Y'); 
$archive_month = get_the_time('m'); 
$archive_day   = get_the_time('d'); 
?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

            <header>
                <div class="post_thumbnail">
                    <?php 
                        if(isset($jws_option['single_blog_imagesize']) && !empty($jws_option['single_blog_imagesize'])) {
                             echo jws_get_post_thumbnail($jws_option['single_blog_imagesize']);
                        }else {
                            echo jws_get_post_thumbnail('full');
                        } 
                    ?>
                </div>
                <h1 class="entry_title">
                    <?php echo get_the_title(); ?>
                </h1>
                <div class="row jws_post_meta">
                    <div class="col-xl-8 col-lg-12 col-12 meta_left">
                        <span class="post_date"><a href="<?php echo esc_url(get_day_link($archive_year, $archive_month, $archive_day)); ?>"><?php echo get_the_date(); ?></a></span> 
                        <span>
                            <span class="post_author"><?php echo '<span>'.esc_html__('By ','netfx').'</span><a href="'.get_author_posts_url( get_the_author_meta( 'ID' ) ).'">'.get_the_author(); ?></a></span> 
                            <span class="post_cat"><?php echo '<span>'.esc_html__(' in ','netfx').'</span>'.get_the_term_list(get_the_ID(), 'category', '', ', '); ?></span>
                        </span>
                        <span class="post_comment"><a href="<?php echo get_the_permalink().'#comments'; ?>"><span class="far fa-comment"></span></a><?php echo esc_html($comments_number); ?></span>
                        <span class="entry-read"><?php echo get_post_meta( get_the_ID(), 'time_read', true );; ?></span>
                    </div>
                    <div class="col-xl-4 col-lg-12 col-12 meta_right">
                        <?php if(function_exists('jws_share_buttons')) echo jws_share_buttons('Share on'); ?>
                    </div>    
               </div>
           </header>
           <div class="entry_content">
                <?php the_content(); ?> 
           </div>
           <footer>
                <?php 
                    echo jws_get_tags();
                    get_template_part( 'template-parts/content/blog/single/template/author_box/author_box1' );
                    get_template_part( 'template-parts/content/blog/single/template/nav/nav2' );  
                 ?>
                <?php
                     // If comments are open or we have at least one comment, load up the comment template.
    				if ( comments_open() || get_comments_number() ) {
    					comments_template();
    				}
                 ?>
            </footer>   
		<?php
		wp_link_pages(
			array(
				'before' => '<div class="page-links">' . esc_html__( 'Pages:', 'netfx' ),
				'after'  => '</div>',
			)
		);
		?>

</article><!-- #post-<?php the_ID(); ?> -->
