<?php
/**
 * Template part for displaying posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package WordPress
 * @subpackage netfx
 * @since 1.0.0
 */
?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>


	<div class="entry_container">
            <div class="container">
                <h1 class="entry_title">
                    <?php echo get_the_title(); ?>
                </h1>
                 <div class="jws_post_meta">
                    <div class="left">
                        <span class="post_cat"><?php echo get_the_term_list(get_the_ID(), 'category', '', ', '); ?></span>
                        <span class="post_author"><?php echo '<span>'.esc_html__('- In ','netfx').'</span>'.get_the_author(); ?></span> 
                    </div>
                    <div class="right">
                        <span class="entry-like"><?php echo esc_attr(post_favorite()); ?></span>
                        <span class="entry-view"><span class="far fa-eye"></span><?php echo gt_get_post_view(); ?></span>
                    </div>
               </div>
           </div>
            <div class="entry_content">
                <?php the_content(); ?> 
            </div>
            <div class="container">
                <?php 
                    echo jws_get_tags();
                    echo jws_share_buttons();
                    jws_post_nav();
                    echo jws_author_render();
                 ?>
                <?php
                     // If comments are open or we have at least one comment, load up the comment template.
    				if ( comments_open() || get_comments_number() ) {
    					comments_template();
    				}
                 ?>
            </div>
		<?php
		wp_link_pages(
			array(
				'before' => '<div class="page-links">' . esc_html__( 'Pages:', 'netfx' ),
				'after'  => '</div>',
			)
		);
		?>
	</div><!-- .entry-content -->


</article><!-- #post-<?php the_ID(); ?> -->
