<?php
/**
 * The template for displaying product content within loops
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/content-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 3.6.0
 */

defined( 'ABSPATH' ) || exit;

global $product , $jws_option;

if(isset($_GET['layout']) && $_GET['layout']) { 
  $layout = $_GET['layout'];
}else {
 $layout = (isset($jws_option['shop_layout']) && !empty($jws_option['shop_layout']) ) ? $jws_option['shop_layout'] : 'layout1';
}

if(isset($_GET['columns']) && $_GET['columns']) { 
    $columns = (isset($_GET['columns']) && !empty($_GET['columns'])) ? esc_attr($_GET['columns']) : '3';
}else {
    $columns = (isset($jws_option['shop_columns']) && !empty($jws_option['shop_columns'])) ? esc_attr($jws_option['shop_columns']) : '3';
}

if(isset($_GET['columns_tablet']) && $_GET['columns_tablet']) { 
   $columns_tablet = (isset($_GET['columns_tablet']) && !empty($_GET['columns_tablet'])) ? esc_attr($_GET['columns_tablet']) : '4';   
}else {
  $columns_tablet = (isset($jws_option['shop_columns_tablet']) && !empty($jws_option['shop_columns_tablet'])) ? esc_attr($jws_option['shop_columns_tablet']) : '4';  
}

if(isset($_GET['columns_mobile']) && $_GET['columns_mobile']) { 
  $columns_mobile = (isset($_GET['columns_mobile']) && !empty($_GET['columns_mobile'])) ? esc_attr($_GET['columns_mobile']) : '6'; 
}else {
  $columns_mobile = (isset($jws_option['shop_columns_mobile']) && !empty($jws_option['shop_columns_mobile'])) ? esc_attr($jws_option['shop_columns_mobile']) : '6';
}

// Ensure visibility.
if ( empty( $product ) || ! $product->is_visible() ) {
	return;
}
if(isset($_GET['type']) && $_GET['type']) {  
  $layout_type = $_GET['type']; 
}else{
     $layout_type = (isset($jws_option['shop_type']) && $jws_option['shop_type']) ? $jws_option['shop_type'] : 'grid';

  
}

$class_see = "inner-flip";
$metro = '';
if ( null!==( get_post_meta(get_the_ID(), 'wc-thumbnail-size', true)) && get_post_meta(get_the_ID(), 'wc-thumbnail-size', true) && $layout_type == 'metro'  )  {
	$large = 2;
	$metro = ' metro-item';    
} else {    
	$large = 1;
}
if($layout!== 'layout_one_column'):

?>
<div class="product-inner">
    <?php
         echo '<div class="product-image">';
    
    	/**
    	 * Hook: woocommerce_before_shop_loop_item_title.
    	 *
    	 * @hooked woocommerce_show_product_loop_sale_flash - 10
    	 * @hooked woocommerce_template_loop_product_thumbnail - 10
    	 */
         woocommerce_template_loop_add_to_cart();
         	/**
    	 * Hook: woocommerce_before_shop_loop_item.
    	 *
    	 * @hooked woocommerce_template_loop_product_link_open - 10
    	 */
         woocommerce_template_loop_product_link_open();
    	do_action( 'woocommerce_before_shop_loop_item' );
             
    	do_action( 'woocommerce_before_shop_loop_item_title' );
        woocommerce_template_loop_product_link_close();
        echo '</div>';
        echo '<div class="product-content">';
    	/**
    	 * Hook: woocommerce_shop_loop_item_title.
    	 *
    	 * @hooked woocommerce_template_loop_product_title - 10
    	 */
    	do_action( 'woocommerce_shop_loop_item_title' );
        echo '<div class="short-description">'; 
            if(isset($_GET['shop_words_per_product']) && $_GET['shop_words_per_product']) { 
              $shop_words_per_product = $_GET['shop_words_per_product'];   
            }else {
                $shop_words_per_product = isset($jws_option['shop_words_per_product']) ?  $jws_option['shop_words_per_product'] : ''; 
            }
            echo (!empty($shop_words_per_product)) ? wp_trim_words( get_the_excerpt(), $shop_words_per_product, '...' ) : get_the_excerpt();
        echo'</div>';
    	/**
    	 * Hook: woocommerce_after_shop_loop_item_title.
    	 *
    	 * @hooked woocommerce_template_loop_rating - 5
    	 * @hooked woocommerce_template_loop_price - 10
    	 */
    	do_action( 'woocommerce_after_shop_loop_item_title' );
    
    	/**
    	 * Hook: woocommerce_after_shop_loop_item.
    	 *
    	 * @hooked woocommerce_template_loop_product_link_close - 5
    	 * @hooked woocommerce_template_loop_add_to_cart - 10
    	 */
        
    	do_action( 'woocommerce_after_shop_loop_item' );
     
        echo '</div>';
   	?>
</div>
	
<?php else: ?>
 <div class="product-inner">
    <?php
         echo '<div class="product-image">';
    
    	/**
    	 * Hook: woocommerce_before_shop_loop_item_title.
    	 *
    	 * @hooked woocommerce_show_product_loop_sale_flash - 10
    	 * @hooked woocommerce_template_loop_product_thumbnail - 10
    	 */
         
         	/**
    	 * Hook: woocommerce_before_shop_loop_item.
    	 *
    	 * @hooked woocommerce_template_loop_product_link_open - 10
    	 */
         woocommerce_template_loop_product_link_open();
         
    	do_action( 'woocommerce_before_shop_loop_item' );
             
    	do_action( 'woocommerce_before_shop_loop_item_title' );
        woocommerce_template_loop_product_link_close();
        echo '</div>';
        echo '<div class="product-content">';
    	/**
    	 * Hook: woocommerce_shop_loop_item_title.
    	 *
    	 * @hooked woocommerce_template_loop_product_title - 10
    	 */
    	do_action( 'woocommerce_shop_loop_item_title' );
        echo '<div class="short-description">'; 
             if(isset($_GET['shop_words_per_product']) && $_GET['shop_words_per_product']) { 
              $shop_words_per_product = $_GET['shop_words_per_product'];   
            }else {
                $shop_words_per_product = $jws_option['shop_words_per_product']; 
            }
            echo (!empty($shop_words_per_product)) ? wp_trim_words( get_the_excerpt(), $shop_words_per_product, '...' ) : get_the_excerpt();
        echo'</div>';
    	/**
    	 * Hook: woocommerce_after_shop_loop_item_title.
    	 *
    	 * @hooked woocommerce_template_loop_rating - 5
    	 * @hooked woocommerce_template_loop_price - 10
    	 */
    	do_action( 'woocommerce_after_shop_loop_item_title' );
        woocommerce_template_loop_add_to_cart();
    	/**
    	 * Hook: woocommerce_after_shop_loop_item.
    	 *
    	 * @hooked woocommerce_template_loop_product_link_close - 5
    	 * @hooked woocommerce_template_loop_add_to_cart - 10
    	 */
        
    	do_action( 'woocommerce_after_shop_loop_item' );
     
        echo '</div>';
   	?>
</div>
 <?php endif; ?>
