<?php
/**
 * Login Form
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/myaccount/form-login.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 4.1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}
global $jws_option;  
wp_enqueue_script( 'jws_woo_myaccount', JWS_URI_PATH. '/assets/js/woocommerce/jws_woo_myaccount.js', array('js-cookie'), '', true );
do_action( 'woocommerce_before_customer_login_form' );
if((isset($jws_option['select-shop-form-login']) && !empty($jws_option['select-shop-form-login']))) {
    echo do_shortcode('[hf_template id="'.$jws_option['select-shop-form-login'].'"]'); 
}else{
  ?>
  <div id="jws-popup-login">
		<div class="jws-login-container">
            <div class="jws-animation">
  	<?php
			     $current_page_id = get_queried_object_id();
			?>  
			<div class="jws-login active">
				<?php
		

				// Set link via priority
				if ( ! empty( $_REQUEST['redirect_to'] ) ) {
					$login_redirect = $_REQUEST['redirect_to'];
				}  else {
					$login_redirect = get_permalink( $current_page_id );
				}

				?>

				<h4 class="title"><?php esc_html_e( 'Login', 'netfx' ); ?></h4>
				<form name="loginpopopform" id="loginform" action="<?php echo esc_url( site_url( 'wp-login.php', 'login_post' ) ); ?>" method="post">
                    <div class="form-group">
                            <label><?php esc_html_e( 'User name or email', 'netfx' ); ?><code>*</code></label>
                            <p class="login-username">
        						<input type="text" name="log" class="input required" value="" size="20" />
        					</p>
                        </div>
					
				
                    <div class="form-group">
                                <label><?php esc_html_e( 'Password', 'netfx' ); ?><code>*</code></label>
                            	<p class="login-password">
            						<input type="password" name="pwd"  class="input required pwd" value="" size="20" />
                                    <span  class="icon eva eva-eye-outline field-icon toggle-password"></span>
                                </p>
                        </div>                    
				

					<div class="forgot-info">
                         
                        <p class="forgetmenot login-remember">
                            <input name="rememberme" type="checkbox" value="forever" id="popupRememberme" /> 
                            <label for="popupRememberme">
                            <?php esc_html_e( 'Remember me', 'netfx' ); ?>
                            </label>
                        </p>
                       <?php echo '<a class="lost-pass-link" href="' . jws_get_lost_password_url() . '" title="' . esc_attr__( 'Forgot password?', 'netfx' ) . '">' . esc_html__( 'Forgot password?', 'netfx' ) . '</a>'; ?>
                    </div>
                    <p class="submit login-submit">
						<input type="submit" name="wp-submit" class="button btn-button btn-dark" value="<?php esc_attr_e( 'Login', 'netfx' ); ?>" />
						<input type="hidden" name="redirect_to" value="<?php echo esc_url( $login_redirect ); ?>" />
						<input type="hidden" name="testcookie" value="1" />
					</p>


				</form>
				<?php
				
					echo '<p class="link-bottom">' . esc_html__( "Don't have any account?", 'netfx' ) . ' <a class="register" href="' . esc_url( jws_get_register_url() ) . '">' . esc_html__( 'Register now', 'netfx' ) . '</a></p>';
				
				?>
			</div>
            	<div class="jws-register">
					<?php

					// Set link via priority
					if ( ! empty( $_REQUEST['redirect_to'] ) ) {
						$register_redirect = $_REQUEST['redirect_to'];
					} else {
						$register_redirect = get_permalink( $current_page_id );
					}

					if ( is_singular( 'lp_course' ) ) {

							$register_redirect = add_query_arg( array( 'enroll-course' => $current_page_id ), $register_redirect );
					
					}
					?>

					<h4 class="title"><?php echo esc_html_x( 'Register', 'Login popup form', 'netfx' ); ?></h4>

					<form class="auto_login" name="registerformpopup" action="<?php echo esc_url( site_url( 'wp-login.php?action=register', 'login_post' ) ); ?>" method="post" novalidate="novalidate">

						<?php wp_nonce_field( 'ajax_register_nonce', 'register_security' ); ?>
                        <div class="form-group">
                            <label><?php esc_html_e( 'User name', 'netfx' ); ?><code>*</code></label>
                            <p class="user_login">
    							<input type="text" name="user_login" class="input required" />
    						</p>
                        </div>
						<div class="form-group">
                            <label><?php esc_html_e( 'Email', 'netfx' ); ?><code>*</code></label>
                            <p class="user_email">
							 <input type="email" name="user_email" class="input required" />
						      </p>
                        </div>
                        <div class="form-group">
                                <label><?php esc_html_e( 'Password', 'netfx' ); ?><code>*</code></label>
                            	<p class="login-password">
                                <input type="password" name="password" class="input required pwd" />
                                <span  class="icon eva eva-eye-outline field-icon toggle-password"></span>
							</p>
                        </div>
                        <div class="form-group">
                                <label><?php esc_html_e( 'Confirm Password', 'netfx' ); ?><code>*</code></label>
                            	<p class="login-password-repeater">
                                <input id="repeat_pwd" type="password" name="repeat_password" class="input required" />
                                <span  class="icon eva eva-eye-outline toggle-password"></span>
							</p>
                        </div>
						<p>
							<input type="hidden" name="redirect_to" value="<?php echo esc_url( $register_redirect ); ?>" />
							<input type="hidden" name="modify_user_notification" value="1">
						</p>

						<?php do_action( 'signup_hidden_fields', 'create-another-site' ); ?>

						<p class="submit">
							<input type="submit" name="wp-submit" class="button btn-button btn-dark" value="<?php echo esc_attr_x( 'Create Account', 'Login popup form', 'netfx' ); ?>" />
						</p>
					</form>
					<?php   echo '<p class="link-bottom">' . esc_html_x( 'Are you a member? ', 'Login now', 'netfx' ) . '<a class="login" href="' . esc_url( jws_get_login_page_url() ) . '">' . esc_html_x( 'Login now', 'Login popup form', 'netfx' ) . '</a></p>'; ?>
                    <div class="meter">
                        <div class="meter-box">
                            <span class="box1"></span>
                            <span class="box2"></span>
                            <span class="box3"></span>
                            <span class="box4"></span>
                              <span class="text-meter"></span>
                        </div>
                      
                      </div>  
                      <div class="jws-password-hint">
                           <?php echo esc_html__('Hint: The password should be at least eight characters long and uppercase letters. To make it stronger, use lower case letters, numbers, and symbols like ! " ? $ % ^ & ).','netfx'); ?>
                     </div>

					<div class="popup-message"></div>
				</div>
            </div>
            </div>
            </div>
  <?php  
} 
do_action( 'woocommerce_after_customer_login_form' ); 