<?php
/**
 * Single Product tabs
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/tabs/tabs.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 3.8.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
global $jws_option;
/**
 * Filter tabs and allow third parties to add their own.
 *
 * Each tab is an array containing title, callback and priority.
 *
 * @see woocommerce_default_product_tabs()
 */
$product_tabs = apply_filters( 'woocommerce_product_tabs', array() );
if ( ! empty( $product_tabs ) ) : ?>

	<div class="woocommerce-tabs wc-tabs-wrapper">
        <?php
        
          $single_product_layout_meta = get_post_meta( get_the_ID(), 'single-layout', true );
            if(isset($single_product_layout_meta) && $single_product_layout_meta) { 
              $layout = $single_product_layout_meta;
            }else {
             $layout = (isset($jws_option['shop_single_layout']) && !empty($jws_option['shop_single_layout'])) ? $jws_option['shop_single_layout'] : 'layout1';
            }
            
        if($layout == 'layout3' || $layout == 'layout5') : $index = 1;?>
            <ul class="accordions">
			<?php foreach ( $product_tabs as $key => $product_tab ) : ?>
				<li class="accordion <?php if($index==1){ echo esc_attr('active');} ?>" id="tab-title-<?php echo esc_attr( $key ); ?>" >
					<div class="cont-header">
						<?php echo wp_kses_post( apply_filters( 'woocommerce_product_' . $key . '_tab_title', $product_tab['title'], $key ) ); ?>
                        <span class="tongle"></span>
					</div>
                	<div class="cont-content">
                        <?php
            				if ( isset( $product_tab['callback'] ) ) {
            					call_user_func( $product_tab['callback'], $key, $product_tab );
            				}
        				?>
        			</div>
				</li>
			<?php $index++; endforeach; ?>
		</ul>
        <?php else: ?>
		<ul class="tabs wc-tabs" role="tablist">
			<?php foreach ( $product_tabs as $key => $product_tab ) : ?>
				<li class="<?php echo esc_attr( $key ); ?>_tab" id="tab-title-<?php echo esc_attr( $key ); ?>" role="tab" aria-controls="tab-<?php echo esc_attr( $key ); ?>">
					<a href="#tab-<?php echo esc_attr( $key ); ?>">
						<?php echo wp_kses_post( apply_filters( 'woocommerce_product_' . $key . '_tab_title', $product_tab['title'], $key ) ); ?>
					</a>
				</li>
			<?php endforeach; ?>
		</ul>
        <div class="jws-group-accordion-wap">
		<?php $i = 1; foreach ( $product_tabs as $key => $product_tab ) : ?>
        <div class="jws-group-accordion <?php if($i == 1) echo esc_attr('accordion-active'); ?>">
            <h3 class="tab-heading"><?php echo esc_html($product_tab['title']); ?><span class="toggle-visible"></span></h3>
			<div class="woocommerce-Tabs-panel woocommerce-Tabs-panel--<?php echo esc_attr( $key ); ?> panel entry-content wc-tab" id="tab-<?php echo esc_attr( $key ); ?>" role="tabpanel" aria-labelledby="tab-title-<?php echo esc_attr( $key ); ?>">
                <?php
    				if ( isset( $product_tab['callback'] ) ) {
    					call_user_func( $product_tab['callback'], $key, $product_tab );
    				}
				?>
			</div>
        </div>
        
		<?php $i++; endforeach; ?>
        </div> 
        <?php endif; ?> 
  
		<?php do_action( 'woocommerce_product_after_tabs' ); ?>
	</div>

<?php endif; ?>